disp('simulating...');
T = 830;
N = 25000;

mu1     = zeros(N,T);
mu2     = zeros(N,T);
muR1    = zeros(N,T);
muR2    = zeros(N,T);
%R1old  = zeros(N,T);
%R2old  = zeros(N,T);
FadjR   = zeros(T,1);
FadjP   = zeros(T,1);
z       = zeros(N,T);
muold   = zeros(2*N,T);
M       = ones(T,1);
g       = zeros(T,1);
eg      = zeros(T,1);

randn('state',0);
rand('state',0);


unif  = nodeunif(N,0,1);

Pt = [1-alpha, alpha; 1-rho, rho];
[vjunk,djunk]=eig(Pt');
fz = vjunk(2,1)/sum(vjunk(:,1));

for t = 1:T

    if t==1
                
shock = randn(N,2);
shock = sa*shock;  

shock = shock.*(rand(N,2)<pshock);
meane=mean(shock,2);
shock(:,1)=shock(:,1)+saa*meane;
shock(:,2)=shock(:,2)+saa*meane;

  ea = shock;
  
  unif = unif(randperm(N));
  ez = zbar*(unif<prctile(unif,fz*100));
  
   z(:,t) =   ez;
   
        state = [gamma/(gamma-1)*ones(N,1),gamma/(gamma-1)*ones(N,1),z(:,t),zeros(N,1),zeros(N,1)];
        
        state(:,1) = max(min(state(:,1),smax(1)),smin(1));
        state(:,2) = max(min(state(:,2),smax(2)),smin(2));
        
        xR = funeval(c_vx(:,4),fspace,state);
        xP = gamma/(gamma-1)*ones(N,1);
        
        v1 = valfunc1(c,fspace,state,xR,e,w);
        v2 = valfunc2(c,fspace,state,xP,e,w);
        v3 = valfunc3(c,fspace,state,[],e,w);
       
        % indicators for choice of action
        
        R1=(v1>=max([v1 v2 v3],[],2) |state(:,1)<=smin(1) |state(:,2)<=smin(2) | state(:,1)>=smax(1) |state(:,2)>=smax(2));
        R2=(v2>=max([v1 v2 v3],[],2) & R1==0);
        R3=(v3>=max([v1 v2 v3],[],2) & R1==0 & R2==0);
        
        muR1(:,t) = xR.*(R1) + state(:,1).*(~R1); 
        muR2(:,t) = xR.*(R1) + state(:,2).*(~R1);
        
        mu1(:,t) = xR.*(R1) + xP.*(R2) + state(:,1).*(R3);
        mu2(:,t) = xR.*(R1) + xP.*(R2) + state(:,2).*(R3);

      % R1old(:,t) = R1;
      % R2old(:,t) = R2;
        
        FadjR(t) = mean(R1);
        FadjP(t) = mean(R2);
muold(:,t) = [state(:,1);state(:,2)];
    else
          
shock = randn(N,2);
shock = sa*shock;  

shock = shock.*(rand(N,2)<pshock);
meane=mean(shock,2);
shock(:,1)=shock(:,1)+saa*meane;
shock(:,2)=shock(:,2)+saa*meane;

        ea     = shock;
       
unif  =   unif(randperm(N));

new = unif(z(:,t-1)==0);
ez(z(:,t-1)==0)=zbar*(new<prctile(new,alpha*100));
        
old = unif(z(:,t-1)>0);
ez(z(:,t-1)>0)=zbar*(old<prctile(old,rho*100));
      
z(:,t)  = ez;
        

        g(t)   = rog*g(t-1)+eg(t);
        M(t)   = M(t-1)*exp(g(t));
                
        state = [muR1(:,t-1).*exp(ea(:,1)-g(t)).*exp(z(:,t)-z(:,t-1)),muR2(:,t-1).*exp(ea(:,2)-g(t)).*exp(z(:,t)-z(:,t-1)),z(:,t),g(t)*ones(N,1),zeros(N,1)];
        
        state(:,1) = max(min(state(:,1),smax(1)),smin(1));
        state(:,2) = max(min(state(:,2),smax(2)),smin(2));
                
        xR = funeval(c_vx(:,4),fspace,state);
        xP = gamma/(gamma-1)*ones(N,1);
        
        v1 = valfunc1(c,fspace,state,xR,e,w);
        v2 = valfunc2(c,fspace,state,xP,e,w);
        v3 = valfunc3(c,fspace,state,[],e,w);
       
        % indicators for choice of action
        
        R1=(v1>=max([v1 v2 v3],[],2) |state(:,1)<=smin(1) |state(:,2)<=smin(2) | state(:,1)>=smax(1) |state(:,2)>=smax(2));
        R2=(v2>=max([v1 v2 v3],[],2) & R1==0);
        R3=(v3>=max([v1 v2 v3],[],2) & R1==0 & R2==0);
        
        muR1(:,t) = xR.*(R1) + state(:,1).*(~R1); 
        muR2(:,t) = xR.*(R1) + state(:,2).*(~R1);
        
        mu1(:,t) = xR.*(R1) + xP.*(R2) + state(:,1).*(R3);
        mu2(:,t) = xR.*(R1) + xP.*(R2) + state(:,2).*(R3);
        
%        R1old(:,t) = R1;
%        R2old(:,t) = R2;
        
        FadjR(t) = mean(R1);
        FadjP(t) = mean(R2);
        muold(:,t) = [state(:,1);state(:,2)];
    end
end

   P1 = (mean(exp(z).^(gamma-1).*mu1.^(1-gamma)).^(1/(1-gamma)))'.*M;
   P2 = (mean(exp(z).^(gamma-1).*mu2.^(1-gamma)).^(1/(1-gamma)))'.*M;
   
   P = (1/2*P1.^(1-theta)+1/2*P2.^(1-theta)).^(1/(1-theta));

   Pf = P;
   P1f = P1;
   P2f = P2;
   FadjRf = FadjR;
   FadjPf = FadjP;
   muoldf = muold;
  % R1oldf = R1old;
  % R2oldf = R2old;
      
   clear mu1 mu2 muR1 muR2 z
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  WITH MONEY SHOCK %%%%%%%%%%%%%%%
   
mu1    = zeros(N,T);
mu2    = zeros(N,T);
muR1   = zeros(N,T);
muR2   = zeros(N,T);
%R1old  = zeros(N,T);
%R2old  = zeros(N,T);
FadjR  = zeros(T,1);
FadjP  = zeros(T,1);
z      = zeros(N,T);
muold  = zeros(2*N,T);
Pm     = zeros(T,1);

M = ones(T,1);
g = zeros(T,1);
eg = randn(T,1)*sshock;
%eg = zeros(T,1); eg(31) = 2*sshock;
unif  = nodeunif(N,0,1);

randn('state',0);
rand('state',0);

for t = 1:T

    if t==1
                
shock = randn(N,2);
shock = sa*shock;  

shock = shock.*(rand(N,2)<pshock);
meane=mean(shock,2);
shock(:,1)=shock(:,1)+saa*meane;
shock(:,2)=shock(:,2)+saa*meane;

   ea = shock;
   
  unif = unif(randperm(N));
  ez = zbar*(unif<prctile(unif,fz*100));
  
  z(:,t) =   ez;
   
        state = [gamma/(gamma-1)*ones(N,1),gamma/(gamma-1)*ones(N,1),z(:,t),zeros(N,1),zeros(N,1)];
        
        state(:,1) = max(min(state(:,1),smax(1)),smin(1));
        state(:,2) = max(min(state(:,2),smax(2)),smin(2));
        
        
        xR = funeval(c_vx(:,4),fspace,state);
        xP = gamma/(gamma-1)*ones(N,1);
        
        v1 = valfunc1(c,fspace,state,xR,e,w);
        v2 = valfunc2(c,fspace,state,xP,e,w);
        v3 = valfunc3(c,fspace,state,[],e,w);
       
        % indicators for choice of action
        
        R1=(v1>=max([v1 v2 v3],[],2) |state(:,1)<=smin(1) |state(:,2)<=smin(2) | state(:,1)>=smax(1) |state(:,2)>=smax(2));
        R2=(v2>=max([v1 v2 v3],[],2) & R1==0);
        R3=(v3>=max([v1 v2 v3],[],2) & R1==0 & R2==0);
        
        muR1(:,t) = xR.*(R1) + state(:,1).*(~R1); 
        muR2(:,t) = xR.*(R1) + state(:,2).*(~R1);
        
        mu1(:,t) = xR.*(R1) + xP.*(R2) + state(:,1).*(R3);
        mu2(:,t) = xR.*(R1) + xP.*(R2) + state(:,2).*(R3);

        
        % R1old(:,t) = R1;
        % R2old(:,t) = R2;
        
        FadjR(t) = mean(R1);
        FadjP(t) = mean(R2);
    
        muold(:,t) = [state(:,1);state(:,2)];
    
    else

          
shock = randn(N,2);
shock = sa*shock;  

shock = shock.*(rand(N,2)<pshock);
meane=mean(shock,2);
shock(:,1)=shock(:,1)+saa*meane;
shock(:,2)=shock(:,2)+saa*meane;

        ea     = shock;
        
unif  =   unif(randperm(N));
new = unif(z(:,t-1)==0);
ez(z(:,t-1)==0)=zbar*(new<prctile(new,alpha*100));
old = unif(z(:,t-1)>0);
ez(z(:,t-1)>0)=zbar*(old<prctile(old,rho*100));
z(:,t)  = ez;

        g(t)   = rog*g(t-1)+eg(t);
        M(t)   = M(t-1)*exp(g(t));
                
        state = [muR1(:,t-1).*exp(ea(:,1)-g(t)).*exp(z(:,t)-z(:,t-1)),muR2(:,t-1).*exp(ea(:,2)-g(t)).*exp(z(:,t)-z(:,t-1)),z(:,t),g(t)*ones(N,1),(Pm(t-1)-g(t))*ones(N,1)];
        
        state(:,1) = max(min(state(:,1),smax(1)),smin(1));
        state(:,2) = max(min(state(:,2),smax(2)),smin(2));
                
        xR = funeval(c_vx(:,4),fspace,state);
        xP = gamma/(gamma-1)*ones(N,1);
        
        v1 = valfunc1(c,fspace,state,xR,e,w);
        v2 = valfunc2(c,fspace,state,xP,e,w);
        v3 = valfunc3(c,fspace,state,[],e,w);
       
        % indicators for choice of action
        
        R1=(v1>=max([v1 v2 v3],[],2) |state(:,1)<=smin(1) |state(:,2)<=smin(2) | state(:,1)>=smax(1) |state(:,2)>=smax(2));
        R2=(v2>=max([v1 v2 v3],[],2) & R1==0);
        R3=(v3>=max([v1 v2 v3],[],2) & R1==0 & R2==0);
        
        muR1(:,t) = xR.*(R1) + state(:,1).*(~R1); 
        muR2(:,t) = xR.*(R1) + state(:,2).*(~R1);
        
        mu1(:,t) = xR.*(R1) + xP.*(R2) + state(:,1).*(R3);
        mu2(:,t) = xR.*(R1) + xP.*(R2) + state(:,2).*(R3);
        
      %  R1old(:,t) = R1;
      %  R2old(:,t) = R2;
        
        FadjR(t) = mean(R1);
        FadjP(t) = mean(R2);
        
   P1 = (mean(exp(z(:,t))'.^(gamma-1).*mu1(:,t)'.^(1-gamma)).^(1/(1-gamma)))'.*M(t);
   P2 = (mean(exp(z(:,t))'.^(gamma-1).*mu2(:,t)'.^(1-gamma)).^(1/(1-gamma)))'.*M(t);
   
   P = (1/2*P1.^(1-theta)+1/2*P2.^(1-theta)).^(1/(1-theta));
        
     Pm(t)  = log(P./M(t))-log(Pf(t));

      muold(:,t) = [state(:,1);state(:,2)];
    end
end

   P1 = (mean(exp(z).^(gamma-1).*mu1.^(1-gamma)).^(1/(1-gamma)))'.*M;
   P2 = (mean(exp(z).^(gamma-1).*mu2.^(1-gamma)).^(1/(1-gamma)))'.*M;
   
   P = (1/2*P1.^(1-theta)+1/2*P2.^(1-theta)).^(1/(1-theta));

% Calvo calibrate to match mode

Cc = zeros(T,1);

lambda = 1 - 0.0545;     % chosen to match 0.58 fraction at mode

AA = (1-beta*rog)/(1-lambda*beta*rog);

for t = 2:T

    Cc(t) = lambda*Cc(t-1) + lambda*AA*g(t);

end
   
   
% Calvo from Midrigan Kehoe
  
% Cc = zeros(T,1);
% 
% alphaR = mean(FadjR);
% alphaT = mean(FadjP);
% 
% AA = (1-alphaT-alphaR)*beta/(1-alphaT*beta)*rog/(1-(1-alphaR)*beta*rog);
% 
% for t = 2:T
%    
%     Cc(t) = -alphaR*AA*(g(t)-alphaT*g(t-1))+(1-alphaR-alphaT)*g(t)+(1-alphaR)*Cc(t-1);
%     
% end

   C = log(M./P)-log(1./Pf);

   figure(1)
   plot(log(P/P(1))-log(Pf/Pf(1)));
   hold on
   plot(log(M/M(1)),'r')
   figure(2)
   plot([C,Cc])
   
   C(1:30)=[];
   Cc(1:30)=[];
   P(1:30)=[];
   M(1:30)=[];
   Pf(1:30)=[];
   g(1:30)=[];
   T = T-30;
   FadjR(1:30)=[];
   
   Cm = reshape(C',4,T/4);   Cm = exp(Cm); Cm = sum(Cm)';   Cm = log(Cm/4);
   Ccm = reshape(Cc,4,T/4); Ccm = exp(Ccm); Ccm = sum(Ccm)'; Ccm = log(Ccm/4);
  
   pai = log(P(2:end)./P(1:end-1)./Pf(2:end).*Pf(1:end-1));
   DP = pai./FadjR(2:end);
   
  
   [Ct,Cd] = hptrend(Cm,14400);
   [Cct,Ccd] = hptrend(Ccm,14400);
   
   % Krusell Smith 
   
   Pk = log(P)-log(Pf)-log(M);
   Pk = Pk - mean(Pk);
  
   ckrusold = ckrus;
   
   reg = ols(Pk(2:end),[ones(size(Pk(2:end))),g(2:end),Pk(1:end-1)]);
   ckrus = reg.beta; 
   
   regc = ols(-Cc(2:end),[ones(size(Cc(2:end))),g(2:end),-Cc(1:end-1)]);
   
   disp('Aggregate Statistics: menu costs')
   disp('R-square, coefficient of P(t) on g(t) and P(t-1), autocorrel. C, std.dev. C')
   [reg.rsqr,reg.beta(2:end)',corr([Cd(1:end-1),Cd(2:end)]),std(Cd)]
   
   disp('Aggregate Statistics: calvo')
      disp('R-square, coefficient of P(t) on g(t) and P(t-1), autocorrel. C, std.dev. C')
   [regc.rsqr,regc.beta(2:end)',corr([Ccd(1:end-1),Ccd(2:end)]),std(Ccd)]
   
   
   disp('KK statistics')
   disp('fraction variance due to intensive margin, correlation infl and fraction adjusters')
   [var(DP)*mean(FadjR).^2/var(pai), corr([FadjR(2:end),abs(pai)])]
   
   
   disp('Errors in Krusell Smith coefficients') 
   norm(ckrusold-ckrus)
   
   save ckrus ckrus;
