% first, plot adj decisions for v = 0 guys
vshock = zbar;

% First, Guys that had R yesterday
state=gridmake(nodeunif(50,smin(1),smax(1)),nodeunif(50,smin(2),smax(2)),vshock,0);

xR   = funeval(c_vx(:,4),fspacenew,state);
xP   = funeval(c_vx(:,5),fspacenew,state);

v1 = valfunc1(c,fspace,state,xR,e,w);
v2 = valfunc2(c,fspace,state,xP,e,w);
v3 = valfunc3(c,fspace,state,[],e,w);

vint = [v1,v2,v3];

c1=(vint(:,1)>=max(vint,[],2));
c2=(vint(:,2)>=max(vint,[],2))&(c1==0);
c3=(vint(:,3)>=max(vint,[],2))&(c1==0&c2==0);


hold on
scatter(log(state(c1,1)/(gamma/(gamma-1))),log(state(c1,2)/(gamma/(gamma-1))),'r','filled');
scatter(log(state(c2,1)/(gamma/(gamma-1))),log(state(c2,2)/(gamma/(gamma-1))),'k','filled');
scatter(log(state(c3,1)/(gamma/(gamma-1))),log(state(c3,2)/(gamma/(gamma-1))),'b','filled');

