function [v1,v2,v3,v4,xR,xP,v14,v24,v34,v41,v42,v43] = saveBelmax(c,fspace,s,e,w)

global beta gamma smin smax

ns = length(s);
z  = s(:,3);

solve1;    xR = x; 
%xR = gamma/(gamma-1)*ones(ns,2);

v1 = valfunc1(c,fspace,s,xR,e,w);

%solve2;    xP = x;
xP = gamma/(gamma-1)*ones(ns,1);

v2 = valfunc2(c,fspace,s,xP,e,w);

v3 = valfunc3(c,fspace,s,[],e,w);
v4 = valfunc4(c,fspace,s,[],e,w);


if nargout > 6
    
        g = feval('menufun','g1',s,xR,[],w);
        v14 = beta*funbas(fspace,g);
        
        g = feval('menufun','g2',s,xP,[],w);
        v24 = beta*funbas(fspace,g);   
        
        g = feval('menufun','g3',s,[],[],w);
        v34 = beta*funbas(fspace,g);
        
        
  nc = size(funbas(fspace,g),2);       
       
  v41 = zeros(ns,nc);      
  v42 = zeros(ns,nc);
  v43 = zeros(ns,nc);
  
         
    for k=1:length(w)                                      % go over all possible values e (discretized distribution of disturbances) can take
      
       kk = k+zeros(ns,1);
       g = feval('menufun','g4',s,[],e(kk,:),w);
       
       prob = w(k,1)*(z==0)+w(k,2)*(z>0);      
       
       Phi = funbas(fspace,g);

       vint = Phi*c(:,1:3);
       vint(:,3) = vint(:,3).*(g(:,1)>smin(1) & g(:,1)<smax(1) & g(:,2)>smin(2) & g(:,2)<smax(2));   % No extrap:  if old R out of bounds, can't use it
       
       c1=(vint(:,1)>=max(vint,[],2));
       c2=(vint(:,2)>=max(vint,[],2))&(c1==0);
       c3=(vint(:,3)>=max(vint,[],2))&(c1==0&c2==0);
       
       v41 = v41 + Phi.*repmat(prob.*c1,1,nc);   
       v42 = v42 + Phi.*repmat(prob.*c2,1,nc);  
       v43 = v43 + Phi.*repmat(prob.*c3,1,nc);  
       
      
    end
end
