disp('simulating...');
T = 350;
N = 500;

mu1     = zeros(N,T);
mu2     = zeros(N,T);
p1      = zeros(N,T);
p2      = zeros(N,T);
a1      = zeros(N,T);
a2      = zeros(N,T);
 
randn('state',0);
rand('state',0);

ainit = zeros(N,2);


for t = 1:T

    if t==1
        
shock = randn(N,2)*sa;
shock = shock.*(rand(N,2)<pshock);
meane=mean(shock,2);
shock(:,1)=shock(:,1)+saa*meane;
shock(:,2)=shock(:,2)+saa*meane;

        ea = shock;
        
        a1(:,t) = ainit(:,1) + ea(:,1)+mua;    
        a2(:,t) = ainit(:,2) + ea(:,2)+mua;
        
        
        state = [gamma/(gamma-1)*ones(N,1),gamma/(gamma-1)*ones(N,1)];
        
        x = gamma/(gamma-1)*ones(N,2);        
                
        v1 = valfunc1(c,fspace,state,x,e,w);
        v2 = valfunc2(c,fspace,state,[],e,w);
       
        % indicators for choice of action
        
        R=(v1>=v2);
        
        mu1(:,t) = x(:,1).*(R) + state(:,1).*(~R);
        mu2(:,t) = x(:,2).*(R) + state(:,2).*(~R);
        
        p1(:,t)  =  mu1(:,t)./exp(a1(:,t));
        p2(:,t)  =  mu2(:,t)./exp(a2(:,t));
        
    else

shock = randn(N,2)*sa;
shock = shock.*(rand(N,2)<pshock);
meane=mean(shock,2);
shock(:,1)=shock(:,1)+saa*meane;
shock(:,2)=shock(:,2)+saa*meane;

        ea = shock;
               
        a1(:,t) = a1(:,t-1) + ea(:,1) + mua;
        a2(:,t) = a2(:,t-1) + ea(:,2) + mua;
                
        state = [mu1(:,t-1).*exp(a1(:,t)-a1(:,t-1)),mu2(:,t-1).*exp(a2(:,t)-a2(:,t-1))];
        
        x = gamma/(gamma-1)*ones(N,2);        
                
        v1 = valfunc1(c,fspace,state,x,e,w);
        v2 = valfunc2(c,fspace,state,[],e,w);
       
        % indicators for choice of action
        
        R=(v1>=v2);
        
        mu1(:,t) = x(:,1).*(R) + state(:,1).*(~R);
        mu2(:,t) = x(:,2).*(R) + state(:,2).*(~R);
        
        p1(:,t)  =  mu1(:,t)./exp(a1(:,t));
        p2(:,t)  =  mu2(:,t)./exp(a2(:,t));
       
    end
end

popt1 = gamma/(gamma-1)./exp(a1);
popt2 = gamma/(gamma-1)./exp(a2);

q1    = exp(a1).^(1-gamma).*p1.^(-gamma);  
q2    = exp(a2).^(1-gamma).*p2.^(-gamma); 

   p1(:,1:50)=[];
   p2(:,1:50)=[];
   popt1(:,1:50)=[];
   popt2(:,1:50)=[];
   q1(:,1:50)=[];
   q2(:,1:50)=[];
   T = T-50;
   a1(:,1:50)=[];
   a2(:,1:50)=[];
   mu1(:,1:50)=[];
   mu2(:,1:50)=[];
   