disp('simulating...');
T = 650;
N = 2500;

mu1     = zeros(N,T);
mu2     = zeros(N,T);
p1      = zeros(N,T);
p2      = zeros(N,T);
a1      = zeros(N,T);
a2      = zeros(N,T);
Fadj    = zeros(T,1);
M       = zeros(T,1);
g       = zeros(T,1);


randn('state',0);
rand('state',0);

ainit = zeros(N,2);
eg    = randn(T,1)*sshock;

for t = 1:T

    if t==1
        
shock = randn(N,2);
shock = sa*shock;  
 
 
shock = shock.*(rand(N,2)<pshock);
 
meane=mean(shock,2);
shock(:,1)=shock(:,1)+saa*meane;
shock(:,2)=shock(:,2)+saa*meane;
        ea = shock;
        
        a1(:,t) = ainit(:,1) + ea(:,1);    
        a2(:,t) = ainit(:,2) + ea(:,2);
        
   g(t) = eg(t);
   M(t) = exp(g(t));
   
        state = [gamma/(gamma-1)*ones(N,1),gamma/(gamma-1)*ones(N,1),g(t)*ones(N,1)];
        
        state(:,1) = max(min(state(:,1),smax(1)),smin(1));
        state(:,2) = max(min(state(:,2),smax(2)),smin(2));
        
        
        x = funeval(c_vx(:,3),fspace,state);          
                
        v1 = valfunc1(c,fspace,state,x,e,w);
        v2 = valfunc2(c,fspace,state,[],e,w);
       
        % indicators for choice of action
        
        R=(v1>=v2 |state(:,1)<=smin(1) |state(:,2)<=smin(2) | state(:,1)>=smax(1) |state(:,2)>=smax(2));

        
        Fadj(t) = mean(R);
        
        mu1(:,t) = x.*(R) + state(:,1).*(~R);
        mu2(:,t) = x.*(R) + state(:,2).*(~R);
        
        p1(:,t)  =  mu1(:,t)./exp(a1(:,t))*M(t);
        p2(:,t)  =  mu2(:,t)./exp(a2(:,t))*M(t);
        
    else

shock = randn(N,2);
shock = sa*shock;  
 
 
shock = shock.*(rand(N,2)<pshock);
 
meane=mean(shock,2);
shock(:,1)=shock(:,1)+saa*meane;
shock(:,2)=shock(:,2)+saa*meane;

        ea = shock;
               
        a1(:,t) = a1(:,t-1) + ea(:,1);
        a2(:,t) = a2(:,t-1) + ea(:,2);
   
  g(t) = rog*g(t-1)+eg(t);
  M(t) = exp(g(t))*M(t-1);
  
  
        state = [mu1(:,t-1).*exp(a1(:,t)-a1(:,t-1)-g(t)),mu2(:,t-1).*exp(a2(:,t)-a2(:,t-1)-g(t)),g(t)*ones(N,1)];
        
        state(:,1) = max(min(state(:,1),smax(1)),smin(1));
        state(:,2) = max(min(state(:,2),smax(2)),smin(2));
        
        
        x = funeval(c_vx(:,3),fspace,state);          
                
        v1 = valfunc1(c,fspace,state,x,e,w);
        v2 = valfunc2(c,fspace,state,[],e,w);
       
        % indicators for choice of action
        
        R=(v1>=v2 |state(:,1)<=smin(1) |state(:,2)<=smin(2) | state(:,1)>=smax(1) |state(:,2)>=smax(2));

        
        Fadj(t) = mean(R);
        
        mu1(:,t) = x.*(R) + state(:,1).*(~R);
        mu2(:,t) = x.*(R) + state(:,2).*(~R);
        
        p1(:,t)  =  mu1(:,t)./exp(a1(:,t))*M(t);
        p2(:,t)  =  mu2(:,t)./exp(a2(:,t))*M(t);
       
    end
end

popt1 = gamma/(gamma-1)./exp(a1).*repmat(M',N,1);
popt2 = gamma/(gamma-1)./exp(a2).*repmat(M',N,1);

q1    = exp(a1).^(1-gamma).*(p1./repmat(M',N,1)).^(-gamma);  
q2    = exp(a2).^(1-gamma).*(p2./repmat(M',N,1)).^(-gamma); 


   p1(:,1:50)=[];
   p2(:,1:50)=[];
   popt1(:,1:50)=[];
   popt2(:,1:50)=[];
   q1(:,1:50)=[];
   q2(:,1:50)=[];
   T = T-50;
   a1(:,1:50)=[];
   a2(:,1:50)=[];
   mu1(:,1:50)=[];
   mu2(:,1:50)=[];
   M(1:50)=[];
   g(1:50)=[];
   
 