disp('simulating...');
T = 830;
N = 25000;

mu1  = zeros(N,T);
mu2  = zeros(N,T);
Fadj = zeros(T,1);
mu1old = zeros(N,T);
mu2old = zeros(N,T);
Rold   = zeros(N,T);

M = ones(T,1);
g = zeros(T,1);
eg = zeros(T,1);

randn('state',0);
rand('state',0);


for t = 1:T

    if t==1
        
                
shock = randn(N,2);
shock = sa*(1-2*ha)^(3/4)*shock.*exp(ha.*shock.^2/2);  

shock = shock.*(rand(N,2)<pshock);
meane=mean(shock,2);
shock(:,1)=shock(:,1)+saa*meane;
shock(:,2)=shock(:,2)+saa*meane;

        ea = shock;
        
        state = [gamma/(gamma-1)*ones(N,1),gamma/(gamma-1)*ones(N,1),zeros(N,1),zeros(N,1),zeros(N,1)];
        
        state(:,1) = max(min(state(:,1),smax(1)),smin(1));
        state(:,2) = max(min(state(:,2),smax(2)),smin(2));
        
        
        x = funeval(c_vx(:,3),fspace,state);          
                
        v1 = valfunc1(c,fspace,state,x,e,w);
        v2 = valfunc2(c,fspace,state,[],e,w);
       
        % indicators for choice of action
        
        R=(v1>=v2 |state(:,1)<=smin(1) |state(:,2)<=smin(2) | state(:,1)>=smax(1) |state(:,2)>=smax(2));
        
        mu1(:,t) = x.*(R) + state(:,1).*(~R);
        mu2(:,t) = x.*(R) + state(:,2).*(~R);
        
        mu1old(:,t) = state(:,1);
        mu2old(:,t) = state(:,2);
        Rold(:,t) =R;
        
    else

          
shock = randn(N,2);
shock = sa*(1-2*ha)^(3/4)*shock.*exp(ha.*shock.^2/2);  

shock = shock.*(rand(N,2)<pshock);
meane=mean(shock,2);
shock(:,1)=shock(:,1)+saa*meane;
shock(:,2)=shock(:,2)+saa*meane;

        ea = shock;

        g(t)   = rog*g(t-1)+eg(t);
        M(t)   = M(t-1)*exp(g(t));
                
        state = [mu1(:,t-1).*exp(ea(:,1)),mu2(:,t-1).*exp(ea(:,2)),zeros(N,1),zeros(N,1),zeros(N,1)];
        
        state(:,1) = max(min(state(:,1),smax(1)),smin(1));
        state(:,2) = max(min(state(:,2),smax(2)),smin(2));
        
        
        x = funeval(c_vx(:,3),fspace,state);      
                
        v1 = valfunc1(c,fspace,state,x,e,w);
        v2 = valfunc2(c,fspace,state,[],e,w);
       
        % indicators for choice of action
        
        R=(v1>=v2 |state(:,1)<=smin(1) |state(:,2)<=smin(2) | state(:,1)>=smax(1) |state(:,2)>=smax(2));
        
        mu1(:,t) = x.*(R) + state(:,1).*(~R);
        mu2(:,t) = x.*(R) + state(:,2).*(~R);
        
        mu1old(:,t) = state(:,1);
        mu2old(:,t) = state(:,2);
        Rold(:,t) =R; 
        
        Fadj(t)=mean(R);
    end
end

   P1 = (mean(mu1.^(1-gamma)).^(1/(1-gamma)))'.*M;
   P2 = (mean(mu2.^(1-gamma)).^(1/(1-gamma)))'.*M;
   
   P = (1/2*P1.^(1-theta)+1/2*P2.^(1-theta)).^(1/(1-theta));

   Pf = P;
   P1f = P1;
   P2f = P2;
   Fadjf = Fadj;
   Roldf = Rold;
   mu1oldf = mu1old;
   mu2oldf = mu2old;
   
   clear mu1 mu2 
   
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  WITH MONEY SHOCK %%%%%%%%%%%%%%%
   
mu1    = zeros(N,T);
mu2    = zeros(N,T);
Fadj   = zeros(T,1);
mu1old = zeros(N,T);
mu2old = zeros(N,T);
Rold   = zeros(N,T);
Pm     = zeros(T,1);
Pmpred = zeros(T,1);
K      = zeros(T,1);
D      = zeros(T,1);
gc     = zeros(T,1);
omega  = zeros(T,1);

M = ones(T,1);
g = zeros(T,1);
eg = randn(T,1)*sshock;
%eg = zeros(T,1); eg(31) = 2*sshock;

randn('state',0);
rand('state',0);

for t = 1:T

    if t==1
          
shock = randn(N,2);
shock = sa*(1-2*ha)^(3/4)*shock.*exp(ha.*shock.^2/2);  

shock = shock.*(rand(N,2)<pshock);
meane=mean(shock,2);
shock(:,1)=shock(:,1)+saa*meane;
shock(:,2)=shock(:,2)+saa*meane;

        ea = shock;
        
        state = [gamma/(gamma-1)*ones(N,1),gamma/(gamma-1)*ones(N,1),g(t)*ones(N,1),zeros(N,1),zeros(N,1)];
        
        state(:,1) = max(min(state(:,1),smax(1)),smin(1));
        state(:,2) = max(min(state(:,2),smax(2)),smin(2));
        
        x = funeval(c_vx(:,3),fspace,state);          
                
        v1 = valfunc1(c,fspace,state,x,e,w);
        v2 = valfunc2(c,fspace,state,[],e,w);
       
        % indicators for choice of action
        
        R=(v1>=v2 |state(:,1)<=smin(1) |state(:,2)<=smin(2) | state(:,1)>=smax(1) |state(:,2)>=smax(2));
        
        Fadj(t)=mean(R);
        
        mu1(:,t) = x.*(R) + state(:,1).*(~R);
        mu2(:,t) = x.*(R) + state(:,2).*(~R);
        
        mu1old(:,t) = state(:,1);
        mu2old(:,t) = state(:,2);
        Rold(:,t) = R;
        
        K(t) = ckrus(2,1)*g(t);
        Pm(t) = ckrus(3,1)*g(t);
       
        omega(t) = ckrus(5,1)*g(t);
        
    else
          
shock = randn(N,2);
shock = sa*(1-2*ha)^(3/4)*shock.*exp(ha.*shock.^2/2);  

shock = shock.*(rand(N,2)<pshock);
meane=mean(shock,2);
shock(:,1)=shock(:,1)+saa*meane;
shock(:,2)=shock(:,2)+saa*meane;

        ea = shock;

        g(t)   = rog*g(t-1)+eg(t);
        M(t)   = M(t-1)*exp(g(t));
          
        omega(t) = ckrus(5,1)*g(t)+ckrus(5,2)*Pm(t-1)+ckrus(5,3)*K(t-1);
        
        state = [mu1(:,t-1).*exp(ea(:,1)-g(t)-omega(t)+omega(t-1)),mu2(:,t-1).*exp(ea(:,2)-g(t)-omega(t)+omega(t-1)),g(t)*ones(N,1),(Pm(t-1)-g(t))*ones(N,1),K(t-1)*ones(N,1)];
        
        state(:,1) = max(min(state(:,1),smax(1)),smin(1));
        state(:,2) = max(min(state(:,2),smax(2)),smin(2));
        
        x = funeval(c_vx(:,3),fspace,state);        
                
        v1 = valfunc1(c,fspace,state,x,e,w);
        v2 = valfunc2(c,fspace,state,[],e,w);
       
        % indicators for choice of action
        
        R=(v1>=v2 |state(:,1)<=smin(1) |state(:,2)<=smin(2) | state(:,1)>=smax(1) |state(:,2)>=smax(2));
        
        mu1(:,t) = x.*(R) + state(:,1).*(~R);
        mu2(:,t) = x.*(R) + state(:,2).*(~R);
        
        mu1old(:,t) = state(:,1);
        mu2old(:,t) = state(:,2);
        Rold(:,t) = R;
        
        Fadj(t)=mean(R);
        
   P1 = (mean(mu1(:,t)'.^(1-gamma)).^(1/(1-gamma)))'.*M(t)*exp(omega(t));
   P2 = (mean(mu2(:,t)'.^(1-gamma)).^(1/(1-gamma)))'.*M(t)*exp(omega(t));
   
   P = (1/2*P1.^(1-theta)+1/2*P2.^(1-theta)).^(1/(1-theta));
        
     Pm(t)  = log(P./M(t))-log(Pf(t));
     Pmpred(t) = ckrus(1)+ckrus(2)*g(t)+ckrus(3)*Pmpred(t-1);
        
        K(t) = ckrus(2,1)*g(t)+ckrus(2,2)*Pm(t-1)+ckrus(2,3)*K(t-1);
        Pm(t) = ckrus(3,1)*g(t)+ckrus(3,2)*Pm(t-1)+ckrus(3,3)*K(t-1);
     
    end
end

   P1 = (mean(mu1.^(1-gamma)).^(1/(1-gamma)))'.*M.*exp(omega);
   P2 = (mean(mu2.^(1-gamma)).^(1/(1-gamma)))'.*M.*exp(omega);
   
   P = (1/2*P1.^(1-theta)+1/2*P2.^(1-theta)).^(1/(1-theta));
  
   C = log(M./P)-log(1./Pf);

Pc = zeros(T,1);
Kc = zeros(T,1);
Cc = zeros(T,1);

% This is meaningless: I do Calvo in dynare

for t = 2:T
    
    Pc(t) = 0.876245*Pc(t-1)  +  -0.043442*Kc(t-1) + -0.713150*g(t);
    Kc(t) = -0.076976*Pc(t-1) +   0.880916*Kc(t-1) +  0.095931*g(t);
    Cc(t) = -0.876245*Pc(t-1) +   0.043442*Kc(t-1) +  1.380161*g(t);
    
end  
   
   figure(1)
   plot(log(P/P(1))-log(Pf/Pf(1)));
   hold on
   plot(log(M/M(1)),'r')
   figure(2)
   plot([C,-Pc])
   
   C(1:30)=[];
   P(1:30)=[];
   M(1:30)=[];
   Pf(1:30)=[];
   g(1:30)=[];
   T = T-30;
   Fadj(1:30)=[];
   K(1:30)=[];
   Pc(1:30)=[];
   Kc(1:30)=[];
   Cc(1:30)=[];
   
    
  
   [Ct,Cd] = hptrend(C,14400);
   [Cct,Ccd] = hptrend(Cc,14400);
   
   % Krusell Smith 
   
   Pk = log(P)-log(Pf)-log(M);
   Pk = Pk - mean(Pk);
  
   
   reg = ols(Pk(2:end),[ones(size(Pk(2:end))),g(2:end),Pk(1:end-1),K(1:end-1)]);
 
   disp('Aggregate Statistics: menu costs')
   disp('R2,coeff on g, P, k, autoc. C, std. dev. C')
   [reg.rsqr,reg.beta(2:end)',corr([Cd(1:end-1),Cd(2:end)]),std(Cd)]
   disp('Aggregate Statistics: Calvo')
   disp('R2,coeff on g, P, k, autoc. C, std. dev. C')
   [reg.rsqr,reg.beta(2:end)',corr([Ccd(1:end-1),Ccd(2:end)]),std(Ccd)]
   
   disp('Errors in Krusell Smith coefficients') 
   norm(reg.beta(2:end)-ckrus(3,:)')

   pars = reg.beta(2:end)';
   save pars pars;
   dynare equilibrium_dynare;
  
   
AA = oo_.dr.ghx(oo_.dr.inv_order_var,:);
BB = oo_.dr.ghu(oo_.dr.inv_order_var,:);
load ckrus
ckrusold = ckrus;
ckrus=[BB(1:5),AA(1:5,2),AA(1:5,1)];
norm(ckrusold-ckrus)
save ckrus ckrus;