function [residual, g1, g2] = equilibrium_dynare_static(y, x, params)
%
% Status : Computes static model for Dynare
%
% Warning : this file is generated automatically by Dynare
%           from model file (.mod)

residual = zeros( 13, 1);

%
% Model equations
%

lhs =y(3);
rhs =params(12)*y(2)+params(13)*y(3)+params(14)*y(10);
residual(1)= lhs-rhs;
lhs =y(6);
rhs =y(7)-y(3);
residual(2)= lhs-rhs;
lhs =0;
rhs =y(3)+y(6)+y(8)-y(6)-y(3)-y(10);
residual(3)= lhs-rhs;
lhs =y(5);
rhs =y(7)*params(4)+y(3)*(1-params(4))+(1-params(4))*y(9);
residual(4)= lhs-rhs;
lhs =(y(6)-y(6))*(1+params(5)*params(11))+params(11)*(y(2)-y(2)*(1-params(5)));
rhs =params(3)*(params(7)*y(9)+params(11)*(1-params(5))*(y(2)-y(2)*(1-params(5))));
residual(5)= lhs-rhs;
lhs =y(3)+y(6);
rhs =y(8)*params(6)/params(3);
residual(6)= lhs-rhs;
lhs =y(10);
rhs =params(2)*y(10)+x(1);
residual(7)= lhs-rhs;
lhs =y(6)*params(10)+y(2)*params(9)-y(2)*(1-params(5))*params(9);
rhs =y(11);
residual(8)= lhs-rhs;
lhs =y(5)+y(11)-y(12);
rhs =y(7);
residual(9)= lhs-rhs;
lhs =y(5)+y(11)-y(2);
rhs =y(3)+y(9);
residual(10)= lhs-rhs;
lhs =y(1);
rhs =y(5)-y(3);
residual(11)= lhs-rhs;
lhs =y(4);
rhs =y(10)+y(5)-y(5);
residual(12)= lhs-rhs;
lhs =y(13);
rhs =(y(2)-y(2)*(1-params(5)))*1/params(5);
residual(13)= lhs-rhs;
if ~isreal(residual)
  residual = real(residual)+imag(residual).^2;
end
if nargout >= 2,
  g1 = zeros(13, 13);

%
% Jacobian matrix
%

  g1(1, 3)=  g1(1, 3)+1;
  g1(1, 2)=  g1(1, 2)+(-params(12));
  g1(1, 3)=  g1(1, 3)+(-params(13));
  g1(1, 10)=  g1(1, 10)+(-params(14));
  g1(2, 3)=  g1(2, 3)+1;
  g1(2, 6)=  g1(2, 6)+1;
  g1(2, 7)=  g1(2, 7)+(-1);
  g1(3, 3)=  g1(3, 3)+(-1);
  g1(3, 6)=  g1(3, 6)+(-1);
  g1(3, 8)=  g1(3, 8)+(-1);
  g1(3, 6)=  g1(3, 6)+1;
  g1(3, 3)=  g1(3, 3)+1;
  g1(3, 10)=  g1(3, 10)+1;
  g1(4, 3)=  g1(4, 3)+(-(1-params(4)));
  g1(4, 7)=  g1(4, 7)+(-params(4));
  g1(4, 5)=  g1(4, 5)+1;
  g1(4, 9)=  g1(4, 9)+(-(1-params(4)));
  g1(5, 2)=  g1(5, 2)+params(11)*(-(1-params(5)));
  g1(5, 6)=  g1(5, 6)+(-(1+params(5)*params(11)));
  g1(5, 6)=  g1(5, 6)+1+params(5)*params(11);
  g1(5, 2)=  g1(5, 2)+params(11)-params(3)*params(11)*(1-params(5))*(-(1-params(5)));
  g1(5, 9)=  g1(5, 9)+(-(params(3)*params(7)));
  g1(5, 2)=  g1(5, 2)+(-(params(3)*params(11)*(1-params(5))));
  g1(6, 3)=  g1(6, 3)+1;
  g1(6, 6)=  g1(6, 6)+1;
  g1(6, 8)=  g1(6, 8)+(-(params(6)/params(3)));
  g1(7, 10)=  g1(7, 10)+1;
  g1(7, 10)=  g1(7, 10)+(-params(2));
  g1(8, 2)=  g1(8, 2)+(-((1-params(5))*params(9)));
  g1(8, 6)=  g1(8, 6)+params(10);
  g1(8, 2)=  g1(8, 2)+params(9);
  g1(8, 11)=  g1(8, 11)+(-1);
  g1(9, 7)=  g1(9, 7)+(-1);
  g1(9, 5)=  g1(9, 5)+1;
  g1(9, 11)=  g1(9, 11)+1;
  g1(9, 12)=  g1(9, 12)+(-1);
  g1(10, 3)=  g1(10, 3)+(-1);
  g1(10, 2)=  g1(10, 2)+(-1);
  g1(10, 5)=  g1(10, 5)+1;
  g1(10, 9)=  g1(10, 9)+(-1);
  g1(10, 11)=  g1(10, 11)+1;
  g1(11, 3)=  g1(11, 3)+1;
  g1(11, 5)=  g1(11, 5)+(-1);
  g1(11, 1)=  g1(11, 1)+1;
  g1(12, 10)=  g1(12, 10)+(-1);
  g1(12, 5)=  g1(12, 5)+1;
  g1(12, 4)=  g1(12, 4)+1;
  g1(12, 5)=  g1(12, 5)+(-1);
  g1(13, 2)=  g1(13, 2)+(-(1/params(5)*(-(1-params(5)))));
  g1(13, 2)=  g1(13, 2)+(-(1/params(5)));
  g1(13, 13)=  g1(13, 13)+1;
  if ~isreal(g1)
    g1 = real(g1)+2*imag(g1);
  end
end
