function [out1,out2] = menufun(flag,s,x,e,w)

global  gamma phiR mua ckrus rog

n = size(s,1);

muold1  = s(:,1);
muold2  = s(:,2);

Delta  = exp(ckrus(1,1)*s(:,3)+ckrus(1,2)*s(:,4)+ckrus(1,3)*s(:,5));
Kprime = exp(ckrus(2,1)*s(:,3)+ckrus(2,2)*s(:,4)+ckrus(2,3)*s(:,5));
PD     = exp(ckrus(3,1)*s(:,3)+ckrus(3,2)*s(:,4)+ckrus(3,3)*s(:,5));
gc     = exp(ckrus(4,1)*s(:,3)+ckrus(4,2)*s(:,4)+ckrus(4,3)*s(:,5));

switch flag

case 'b'  % bound for first control
 
  out1 =  exp(-0.05)*gamma/(gamma-1)*ones(n,1);  
  out2 =  exp(+0.05)*gamma/(gamma-1)*ones(n,1);

case 'f1' 
    
mu1 = x;
mu2 = x;

out1 = ((mu1-1).*mu1.^(-gamma)+(mu2-1).*mu2.^(-gamma)).*Delta.^(1-gamma)-phiR;

case 'f2'
    
mu1 = muold1;
mu2 = muold2;

out1 = ((mu1-1).*mu1.^(-gamma)+(mu2-1).*mu2.^(-gamma)).*Delta.^(1-gamma);

case 'g1'
    
mu1 = x;
mu2 = x;

out1=[mu1, mu2, rog*s(:,3), log(PD)-rog*s(:,3),  log(Kprime)];

case 'g2'
    
out1=[muold1, muold2,   rog*s(:,3),   log(PD)-rog*s(:,3),  log(Kprime)];

case 'g3'    
  
out1=[muold1.*exp(mua+e(:,1)-log(gc)),  muold2.*exp(mua+e(:,2)-log(gc)), s(:,3), s(:,4), s(:,5)];

end