function [residual, g1, g2, g3] = equilibrium_dynare_dynamic(y, x, params, it_)
%
% Status : Computes dynamic model for Dynare
%
% Warning : this file is generated automatically by Dynare
%           from model file (.mod)

%
% Model equations
%

residual = zeros(15, 1);
T117 = (params(10)+params(5)*params(9))^(-1);
lhs =y(6);
rhs =params(13)*y(1)+params(14)*y(2)+params(15)*y(13);
residual(1)= lhs-rhs;
lhs =y(9);
rhs =y(10)-y(6);
residual(2)= lhs-rhs;
lhs =0;
rhs =y(6)+y(9)+y(11)-y(22)-y(20)-y(24);
residual(3)= lhs-rhs;
lhs =y(8);
rhs =y(10)*params(4)+y(6)*params(16)+params(16)*y(12)+y(6)*(1-params(4)-params(16));
residual(4)= lhs-rhs;
lhs =(y(22)-y(9))*(1+params(5)*params(12))+params(12)*(y(5)-y(1)*(1-params(5)));
rhs =params(3)*(params(7)*y(23)+params(12)*(1-params(5))*(y(19)-y(5)*(1-params(5))));
residual(5)= lhs-rhs;
lhs =y(6)+y(9);
rhs =y(11)*params(6)/params(3);
residual(6)= lhs-rhs;
lhs =y(13);
rhs =params(2)*y(3)+x(it_, 1);
residual(7)= lhs-rhs;
lhs =y(9)*params(10)+y(5)*params(9)-y(1)*(1-params(5))*params(9)+params(11)*y(17);
rhs =y(14);
residual(8)= lhs-rhs;
lhs =y(8)+y(14)-y(15);
rhs =y(10);
residual(9)= lhs-rhs;
lhs =y(8)+y(14)-y(1);
rhs =y(6)+y(12);
residual(10)= lhs-rhs;
lhs =y(8)+y(14)-y(17);
rhs =y(6);
residual(11)= lhs-rhs;
lhs =y(4);
rhs =y(8)-y(6);
residual(12)= lhs-rhs;
lhs =y(7);
rhs =y(24)+y(21)-y(8);
residual(13)= lhs-rhs;
lhs =y(16);
rhs =(y(5)-y(1)*(1-params(5)))*1/params(5);
residual(14)= lhs-rhs;
lhs =y(18);
rhs =(y(9)*params(10)+y(5)*params(9)-y(1)*(1-params(5))*params(9))*T117;
residual(15)= lhs-rhs;
if nargout >= 2,
  g1 = zeros(15, 25);

%
% Jacobian matrix
%

  g1(1, 6)=  g1(1, 6)+1;
  g1(1, 1)=  g1(1, 1)+(-params(13));
  g1(1, 2)=  g1(1, 2)+(-params(14));
  g1(1, 13)=  g1(1, 13)+(-params(15));
  g1(2, 6)=  g1(2, 6)+1;
  g1(2, 9)=  g1(2, 9)+1;
  g1(2, 10)=  g1(2, 10)+(-1);
  g1(3, 6)=  g1(3, 6)+(-1);
  g1(3, 9)=  g1(3, 9)+(-1);
  g1(3, 11)=  g1(3, 11)+(-1);
  g1(3, 22)=  g1(3, 22)+1;
  g1(3, 20)=  g1(3, 20)+1;
  g1(3, 24)=  g1(3, 24)+1;
  g1(4, 6)=  g1(4, 6)+(-(params(16)+1-params(4)-params(16)));
  g1(4, 10)=  g1(4, 10)+(-params(4));
  g1(4, 8)=  g1(4, 8)+1;
  g1(4, 12)=  g1(4, 12)+(-params(16));
  g1(5, 1)=  g1(5, 1)+params(12)*(-(1-params(5)));
  g1(5, 9)=  g1(5, 9)+(-(1+params(5)*params(12)));
  g1(5, 22)=  g1(5, 22)+1+params(5)*params(12);
  g1(5, 5)=  g1(5, 5)+params(12)-params(3)*params(12)*(1-params(5))*(-(1-params(5)));
  g1(5, 23)=  g1(5, 23)+(-(params(3)*params(7)));
  g1(5, 19)=  g1(5, 19)+(-(params(3)*params(12)*(1-params(5))));
  g1(6, 6)=  g1(6, 6)+1;
  g1(6, 9)=  g1(6, 9)+1;
  g1(6, 11)=  g1(6, 11)+(-(params(6)/params(3)));
  g1(7, 13)=  g1(7, 13)+1;
  g1(7, 3)=  g1(7, 3)+(-params(2));
  g1(7, 25)=  g1(7, 25)+(-1);
  g1(8, 1)=  g1(8, 1)+(-((1-params(5))*params(9)));
  g1(8, 9)=  g1(8, 9)+params(10);
  g1(8, 5)=  g1(8, 5)+params(9);
  g1(8, 17)=  g1(8, 17)+params(11);
  g1(8, 14)=  g1(8, 14)+(-1);
  g1(9, 10)=  g1(9, 10)+(-1);
  g1(9, 8)=  g1(9, 8)+1;
  g1(9, 14)=  g1(9, 14)+1;
  g1(9, 15)=  g1(9, 15)+(-1);
  g1(10, 6)=  g1(10, 6)+(-1);
  g1(10, 1)=  g1(10, 1)+(-1);
  g1(10, 8)=  g1(10, 8)+1;
  g1(10, 12)=  g1(10, 12)+(-1);
  g1(10, 14)=  g1(10, 14)+1;
  g1(11, 6)=  g1(11, 6)+(-1);
  g1(11, 8)=  g1(11, 8)+1;
  g1(11, 17)=  g1(11, 17)+(-1);
  g1(11, 14)=  g1(11, 14)+1;
  g1(12, 6)=  g1(12, 6)+1;
  g1(12, 8)=  g1(12, 8)+(-1);
  g1(12, 4)=  g1(12, 4)+1;
  g1(13, 24)=  g1(13, 24)+(-1);
  g1(13, 8)=  g1(13, 8)+1;
  g1(13, 7)=  g1(13, 7)+1;
  g1(13, 21)=  g1(13, 21)+(-1);
  g1(14, 1)=  g1(14, 1)+(-(1/params(5)*(-(1-params(5)))));
  g1(14, 5)=  g1(14, 5)+(-(1/params(5)));
  g1(14, 16)=  g1(14, 16)+1;
  g1(15, 1)=  g1(15, 1)+(-(T117*(-((1-params(5))*params(9)))));
  g1(15, 9)=  g1(15, 9)+(-(params(10)*T117));
  g1(15, 5)=  g1(15, 5)+(-(params(9)*T117));
  g1(15, 18)=  g1(15, 18)+1;
end
if nargout >= 3,
  g2 = sparse([],[],[], 15, 625, 3125);

%
% Hessian matrix
%

end;
