function [out1,out2] = menufun(flag,s,x,e,w)

global  gamma phiR kappa rog

n = size(s,1);

muRold1  = s(:,1);
muRold2  = s(:,2);
z        = s(:,3);

switch flag

case 'b'  % bound for first control
 
  out1 =  exp(-0.1)*gamma/(gamma-1)*ones(n,1);  
  out2 =  exp(+0.1)*gamma/(gamma-1)*ones(n,1);

case 'f1' 
    
mu1 = x;
mu2 = x;

out1 = exp(z).^(gamma-1).*((mu1-1).*mu1.^(-gamma)+(mu2-1).*mu2.^(-gamma))-phiR;

case 'f2'
    
mu1 = x;
mu2 = x;

out1 = exp(z).^(gamma-1).*((mu1-1).*mu1.^(-gamma)+(mu2-1).*mu2.^(-gamma))-kappa;

case 'f3'
    
mu1 = muRold1;
mu2 = muRold2;

out1 = exp(z).^(gamma-1).*((mu1-1).*mu1.^(-gamma)+(mu2-1).*mu2.^(-gamma));


case 'g1'
    
mu1 = x;
mu2 = x;

out1=[mu1, mu2, z,rog*s(:,4)];

case 'g2'
    
out1=[muRold1, muRold2, z, rog*s(:,4)];

case 'g3'    
   
out1=[muRold1, muRold2, z, rog*s(:,4)];

case 'g4'    
     
out1=[muRold1.*exp(e(:,1)+e(:,3)-s(:,4)),  muRold2.*exp(e(:,2)+e(:,3)-z-s(:,4)),  e(:,3), s(:,4)];

end