clear all; 
clc; 

load alldata_all

prices = allp;
oldprices = prices; 
[T,K] = size(prices);
share=sum(allq);
share = share/sum(share);
share = repmat(share,T,1);

wind = 5;        % # of months around current price used to compute modal price
cutoff = 1/3;    % of used less than cutoff times, count as temporary price
acc = .5;        % how many times should price be available for modal calculation to count?

temp=zeros(size(prices));  %0: unclassified, 1: permanent, 2: temporary
temp1=temp;                %this records what the temporary price is doing
                           %1 means
modalprice=zeros(T,K);
fract=zeros(T,K);

for i=1:K
 
   index=find(prices(:,i)>0);
     
   for j=index(1):index(end)
    if prices(j,i)>0
    
       
   junk=prices(max(j-wind,1):min(j+wind,T),i);
   junk=junk(junk>0);
  
   if length(junk)-1>acc*(2*wind+1)
        
       if all(junk==junk(1))  %hist is funny if all identical
           
           pmode=junk(1);
           fract(j,i)=1;
           
       else
       
        [njunk,xjunk]=hist(junk,unique(junk));
              
        djunk=sortrows([vec(njunk),vec(xjunk)],1);
        
        pmode=djunk(end,2);
        fract(j,i)=djunk(end,1)/length(junk);
       
     end
       
       modalprice(j,i)=pmode;
       
   end
   end
   end
    
end


pR=zeros(T,K);

for i=1:K
   
    index=find(prices(:,i)>0);
  
for j=index(1):index(end)
      if j==1
          pR(j,i)=modalprice(j,i).*(modalprice(j,i)>0)+prices(j,i).*(modalprice(j,i)==0);
      else
          if modalprice(j,i)>0 
              pR(j,i)=modalprice(j,i).*(fract(j,i)>=cutoff&modalprice(j,i)==prices(j,i))+pR(j-1,i).*(~((fract(j,i)>=cutoff&modalprice(j,i)==prices(j,i))));
          else
              pR(j,i)=pR(j-1,i);
          end
      end
end

end

 for i=1:K  % if p_t is mode, make p_t+1 /p_t-1 modes as well if they are the same as p_t
  for ss = 1:wind
          index=find(prices(2:end,i)==prices(1:end-1,i)&prices(2:end,i)~=0&prices(1:end-1,i)~=0)+1;  %index of dates where prices don't change
          nommatch=pR(index,i)~=pR(index-1,i)&pR(index-1,i)~=0&pR(index,i)~=0;
          pmatch=pR(index-1,i)==prices(index-1,i);
          cmatch=pR(index,i)==prices(index,i);
          pR(index(nommatch&cmatch)-1,i)=prices(index(nommatch&cmatch),i);
          pR(index(nommatch&pmatch),i)=prices(index(nommatch&pmatch)-1,i);
 end
end

plotind=0;    % plot

if plotind==1
prices(prices==0)=NaN;
pR(isnan(prices))=NaN;
pR(pR==0)=NaN;
i=122;
plot(prices(1:100,i),'-b.','LineWidth',2,'MarkerSize',12);
hold on
plot(pR(1:100,i),'r','LineWidth',2);
end

prices=pR;
prices(oldprices==0)=0;
oldprices(prices==0)=0;

