   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  WITH MONEY SHOCK %%%%%%%%%%%%%%%
   
mu1    = zeros(N,T);
mu1old = zeros(N,T);
Rold   = zeros(N,T);

randn('state',0);
rand('state',0);

for t = 1:T

    if t==1
          
shock = randn(N,1);
shock = sa*(1-2*ha)^(3/4)*shock.*exp(ha.*shock.^2/2);  

        ea = shock;
        
        state = [gamma/(gamma-1)*ones(N,1),g(t)*ones(N,1),zeros(N,1)];
        
        state(:,1) = max(min(state(:,1),smax(1)),smin(1));
 
        
        x = funeval(c_vx(:,3),fspace,state);          
                
          %v1 = valfunc1(c,fspace,state,x,e,w);
        %v2 = valfunc2(c,fspace,state,[],e,w);
       
        % indicators for choice of action
        
        R = rand(N,1); R = R<prctile(R,Fadj(t)*100);
        
        mu1(:,t) = x.*(R) + state(:,1).*(~R);
        mu1old(:,t) = state(:,1);
        Rold(:,t) = R;
        
    else
          
shock = randn(N,1);
shock = sa*(1-2*ha)^(3/4)*shock.*exp(ha.*shock.^2/2);  

        ea = shock;
              
        state = [mu1(:,t-1).*exp(ea(:,1)+mua-g(t)),g(t)*ones(N,1),Pm(t-1)*ones(N,1)];
        
        state(:,1) = max(min(state(:,1),smax(1)),smin(1));
                
        x = funeval(c_vx(:,3),fspace,state);        
                
          %v1 = valfunc1(c,fspace,state,x,e,w);
        %v2 = valfunc2(c,fspace,state,[],e,w);
       
        % indicators for choice of action
        
        R = rand(N,1); R = R<prctile(R,Fadj(t)*100);
        
        
        mu1(:,t) = x.*(R) + state(:,1).*(~R);
               
        mu1old(:,t) = state(:,1);
       
        Rold(:,t) = R;
        
          
   P = (mean(mu1(:,t)'.^(1-gamma)).^(1/(1-gamma)))'.*M(t);
      
        
   Pm(t)  = log(P./M(t))-log(Pf(t));
   Pmpred(t) = ckrus(1)+ckrus(2)*g(t)+ckrus(3)*Pmpred(t-1);
        
    end
end
  
   P = (mean(mu1.^(1-gamma)).^(1/(1-gamma)))'.*M;
   
Cc = zeros(T,1);
lambda = 1-mean(Fadj);
AA = (1-beta*rog)/(1-lambda*beta*rog);

for t = 2:T
   
    Cc(t) = lambda*Cc(t-1) + lambda*AA*g(t);
    
end

  
   
   C = log(M./P)-log(1./Pf);

   figure(1)
   plot(log(P/P(1))-log(Pf/Pf(1)));
   hold on
   plot(log(M/M(1)),'r')
   figure(2)
   plot([C,Cc])
   
  
   
   C(1:30)=[];
   Cc(1:30)=[];
   P(1:30)=[];
   M(1:30)=[];
   Pf(1:30)=[];
   g(1:30)=[];
   T = T-30;
   Fadj(1:30)=[];
   Fadjf(1:30)=[];
   
   Cm = reshape(C',4,T/4);   Cm = exp(Cm); Cm = sum(Cm)';   Cm = log(Cm/4);
   Ccm = reshape(Cc,4,T/4);  Ccm = exp(Ccm); Ccm = sum(Ccm)'; Ccm = log(Ccm/4);
  
   pai = log(P(2:end)./P(1:end-1)./Pf(2:end).*Pf(1:end-1));
   DP = pai./(Fadj(2:end));
   
   
   [Ct,Cd] = hptrend(Cm,14400);
   [Cct,Ccd] = hptrend(Ccm,14400);
   
   % Krusell Smith 
   
   Pk = log(P)-log(Pf)-log(M);
   Pk = Pk - mean(Pk);
  
   ckrusold = ckrus;
   
   reg = ols(Pk(2:end),[ones(size(Pk(2:end))),g(2:end),Pk(1:end-1)]);
   ckrus = reg.beta; 
   
   disp('Aggregate Statistics: menu costs')
   [reg.rsqr,reg.beta(2:end)',corr([Cd(1:end-1),Cd(2:end)]),std(Cd)]
   
   disp('Aggregate Statistics: calvo')
   [1,-lambda*AA,lambda, corr([Ccd(1:end-1),Ccd(2:end)]),std(Ccd)]
   
   disp('KK statistics')
   [var(DP)*mean(Fadj).^2/var(pai), corr([Fadj(2:end),abs(pai)])]
   
   
   disp('Errors in Krusell Smith coefficients') 
   norm(ckrusold-ckrus)
   
   save ckrus ckrus;
