disp('simulating...');
T = 650;
N = 500;

mu1     = zeros(N,T);
p1      = zeros(N,T);
a1      = zeros(N,T);
Fadj    = zeros(T,1);
M       = zeros(T,1);
g       = zeros(T,1);


randn('state',0);
rand('state',0);

ainit = zeros(N,2);
eg    = randn(T,1)*sshock;

for t = 1:T

    if t==1
        
shock = randn(N,1);
shock = sa*shock;  
shock = shock.*(rand(N,1)<pshock);

        ea = shock;
        
        a1(:,t) = ainit(:,1) + ea(:,1);    

        
   g(t) = eg(t);
   M(t) = exp(g(t));
   
        state = [gamma/(gamma-1)*ones(N,1),g(t)*ones(N,1)];
        
        state(:,1) = max(min(state(:,1),smax(1)),smin(1));
        
        x = funeval(c_vx(:,3),fspace,state);          
                
        v1 = valfunc1(c,fspace,state,x,e,w);
        v2 = valfunc2(c,fspace,state,[],e,w);
       
        % indicators for choice of action
        
        R=(v1>=v2 |state(:,1)<=smin(1) | state(:,1)>=smax(1) |rand(N,1)<pphi);

        Fadj(t) = mean(R);
        
        mu1(:,t) = x.*(R) + state(:,1).*(~R);
        
        p1(:,t)  =  mu1(:,t)./exp(a1(:,t))*M(t);
        
    else
        
  

shock = randn(N,1);
shock = sa*shock;  
shock = shock.*(rand(N,1)<pshock);
       ea = shock;

        a1(:,t) = a1(:,t-1) + ea;
   
  g(t) = rog*g(t-1)+eg(t);
  M(t) = exp(g(t))*M(t-1);
  
        state = [mu1(:,t-1).*exp(a1(:,t)-a1(:,t-1)-g(t)),g(t)*ones(N,1)];
        
        state(:,1) = max(min(state(:,1),smax(1)),smin(1));
        
        x = funeval(c_vx(:,3),fspace,state);          
                
        v1 = valfunc1(c,fspace,state,x,e,w);
        v2 = valfunc2(c,fspace,state,[],e,w);
       
        % indicators for choice of action
        
        R=(v1>=v2 |state(:,1)<=smin(1) | state(:,1)>=smax(1)|rand(N,1)<pphi);

        Fadj(t) = mean(R);
        mu1(:,t) = x.*(R) + state(:,1).*(~R);
        p1(:,t)  =  mu1(:,t)./exp(a1(:,t))*M(t);
       
    end
end

% Calvo
  
Cc = zeros(T,1);
lambda = 1-mean(Fadj);
AA = (1-beta*rog)/(1-lambda*beta*rog);
for t = 2:T
   Cc(t) = lambda*Cc(t-1) + lambda*AA*g(t);
end


popt1 = gamma/(gamma-1)./exp(a1).*repmat(M',N,1);

q1    = exp(a1).^(1-gamma).*(p1./repmat(M',N,1)).^(-gamma);  

   p1(:,1:50)=[];
   popt1(:,1:50)=[];
   q1(:,1:50)=[];
   T = T-50;
   a1(:,1:50)=[];
   mu1(:,1:50)=[];
   M(1:50)=[];
   g(1:50)=[];
   
  