function [residual, g1, g2, g3] = equilibrium_dynare_calvo_dynamic(y, x, params, it_)
%
% Status : Computes dynamic model for Dynare
%
% Warning : this file is generated automatically by Dynare
%           from model file (.mod)

%
% Model equations
%

residual = zeros(12, 1);
lhs =y(14);
rhs =params(14)*params(3)*y(21)+(1-params(14)*params(3))*y(7)+params(14)*params(3)*params(2)*y(10);
residual(1)= lhs-rhs;
lhs =y(4);
rhs =params(14)*(y(1)-y(10))+y(14)*(1-params(14));
residual(2)= lhs-rhs;
lhs =y(5);
rhs =y(6)-y(4);
residual(3)= lhs-rhs;
lhs =0;
rhs =y(4)+y(5)+y(8)-y(17)-y(16)-y(19);
residual(4)= lhs-rhs;
lhs =y(7);
rhs =y(6)*params(4)+y(4)*(1-params(4))+(1-params(4))*y(9);
residual(5)= lhs-rhs;
lhs =(y(17)-y(5))*(1+params(5)*params(15))+params(15)*(y(11)-(1-params(5))*y(3));
rhs =params(3)*(params(7)*y(18)+params(15)*(1-params(5))*(y(20)-y(11)*(1-params(5))));
residual(6)= lhs-rhs;
lhs =y(4)+y(5);
rhs =y(8)*params(6)/params(3);
residual(7)= lhs-rhs;
lhs =y(10);
rhs =params(2)*y(2)+x(it_, 1);
residual(8)= lhs-rhs;
lhs =y(5)*params(10)+y(11)*params(9)-y(3)*(1-params(5))*params(9);
rhs =y(12);
residual(9)= lhs-rhs;
lhs =y(7)+y(12)-y(13);
rhs =y(6);
residual(10)= lhs-rhs;
lhs =y(7)+y(12)-y(3);
rhs =y(4)+y(9);
residual(11)= lhs-rhs;
lhs =y(15);
rhs =(y(11)-(1-params(5))*y(3))*1/params(5);
residual(12)= lhs-rhs;
if nargout >= 2,
  g1 = zeros(12, 22);

%
% Jacobian matrix
%

  g1(1, 14)=  g1(1, 14)+1;
  g1(1, 21)=  g1(1, 21)+(-(params(14)*params(3)));
  g1(1, 7)=  g1(1, 7)+(-(1-params(14)*params(3)));
  g1(1, 10)=  g1(1, 10)+(-(params(14)*params(3)*params(2)));
  g1(2, 14)=  g1(2, 14)+(-(1-params(14)));
  g1(2, 10)=  g1(2, 10)+params(14);
  g1(2, 4)=  g1(2, 4)+1;
  g1(2, 1)=  g1(2, 1)+(-params(14));
  g1(3, 4)=  g1(3, 4)+1;
  g1(3, 5)=  g1(3, 5)+1;
  g1(3, 6)=  g1(3, 6)+(-1);
  g1(4, 4)=  g1(4, 4)+(-1);
  g1(4, 5)=  g1(4, 5)+(-1);
  g1(4, 8)=  g1(4, 8)+(-1);
  g1(4, 17)=  g1(4, 17)+1;
  g1(4, 16)=  g1(4, 16)+1;
  g1(4, 19)=  g1(4, 19)+1;
  g1(5, 7)=  g1(5, 7)+1;
  g1(5, 4)=  g1(5, 4)+(-(1-params(4)));
  g1(5, 6)=  g1(5, 6)+(-params(4));
  g1(5, 9)=  g1(5, 9)+(-(1-params(4)));
  g1(6, 5)=  g1(6, 5)+(-(1+params(5)*params(15)));
  g1(6, 17)=  g1(6, 17)+1+params(5)*params(15);
  g1(6, 11)=  g1(6, 11)+params(15)-params(3)*params(15)*(1-params(5))*(-(1-params(5)));
  g1(6, 3)=  g1(6, 3)+params(15)*(-(1-params(5)));
  g1(6, 18)=  g1(6, 18)+(-(params(3)*params(7)));
  g1(6, 20)=  g1(6, 20)+(-(params(3)*params(15)*(1-params(5))));
  g1(7, 4)=  g1(7, 4)+1;
  g1(7, 5)=  g1(7, 5)+1;
  g1(7, 8)=  g1(7, 8)+(-(params(6)/params(3)));
  g1(8, 10)=  g1(8, 10)+1;
  g1(8, 2)=  g1(8, 2)+(-params(2));
  g1(8, 22)=  g1(8, 22)+(-1);
  g1(9, 5)=  g1(9, 5)+params(10);
  g1(9, 11)=  g1(9, 11)+params(9);
  g1(9, 3)=  g1(9, 3)+(-((1-params(5))*params(9)));
  g1(9, 12)=  g1(9, 12)+(-1);
  g1(10, 7)=  g1(10, 7)+1;
  g1(10, 6)=  g1(10, 6)+(-1);
  g1(10, 12)=  g1(10, 12)+1;
  g1(10, 13)=  g1(10, 13)+(-1);
  g1(11, 7)=  g1(11, 7)+1;
  g1(11, 4)=  g1(11, 4)+(-1);
  g1(11, 9)=  g1(11, 9)+(-1);
  g1(11, 3)=  g1(11, 3)+(-1);
  g1(11, 12)=  g1(11, 12)+1;
  g1(12, 11)=  g1(12, 11)+(-(1/params(5)));
  g1(12, 3)=  g1(12, 3)+(-(1/params(5)*(-(1-params(5)))));
  g1(12, 15)=  g1(12, 15)+1;
end
if nargout >= 3,
  g2 = sparse([],[],[], 12, 484, 2420);

%
% Hessian matrix
%

end;
