function [residual, g1, g2] = equilibrium_dynare_calvo_static(y, x, params)
%
% Status : Computes static model for Dynare
%
% Warning : this file is generated automatically by Dynare
%           from model file (.mod)

residual = zeros( 12, 1);

%
% Model equations
%

lhs =y(11);
rhs =params(14)*params(3)*y(11)+(1-params(14)*params(3))*y(4)+params(14)*params(3)*params(2)*y(7);
residual(1)= lhs-rhs;
lhs =y(1);
rhs =params(14)*(y(1)-y(7))+y(11)*(1-params(14));
residual(2)= lhs-rhs;
lhs =y(2);
rhs =y(3)-y(1);
residual(3)= lhs-rhs;
lhs =0;
rhs =y(1)+y(2)+y(5)-y(2)-y(1)-y(7);
residual(4)= lhs-rhs;
lhs =y(4);
rhs =y(3)*params(4)+y(1)*(1-params(4))+(1-params(4))*y(6);
residual(5)= lhs-rhs;
lhs =(y(2)-y(2))*(1+params(5)*params(15))+params(15)*(y(8)-(1-params(5))*y(8));
rhs =params(3)*(params(7)*y(6)+params(15)*(1-params(5))*(y(8)-y(8)*(1-params(5))));
residual(6)= lhs-rhs;
lhs =y(1)+y(2);
rhs =y(5)*params(6)/params(3);
residual(7)= lhs-rhs;
lhs =y(7);
rhs =params(2)*y(7)+x(1);
residual(8)= lhs-rhs;
lhs =y(2)*params(10)+y(8)*params(9)-y(8)*(1-params(5))*params(9);
rhs =y(9);
residual(9)= lhs-rhs;
lhs =y(4)+y(9)-y(10);
rhs =y(3);
residual(10)= lhs-rhs;
lhs =y(4)+y(9)-y(8);
rhs =y(1)+y(6);
residual(11)= lhs-rhs;
lhs =y(12);
rhs =(y(8)-(1-params(5))*y(8))*1/params(5);
residual(12)= lhs-rhs;
if ~isreal(residual)
  residual = real(residual)+imag(residual).^2;
end
if nargout >= 2,
  g1 = zeros(12, 12);

%
% Jacobian matrix
%

  g1(1, 11)=  g1(1, 11)+1;
  g1(1, 11)=  g1(1, 11)+(-(params(14)*params(3)));
  g1(1, 4)=  g1(1, 4)+(-(1-params(14)*params(3)));
  g1(1, 7)=  g1(1, 7)+(-(params(14)*params(3)*params(2)));
  g1(2, 11)=  g1(2, 11)+(-(1-params(14)));
  g1(2, 7)=  g1(2, 7)+params(14);
  g1(2, 1)=  g1(2, 1)+1;
  g1(2, 1)=  g1(2, 1)+(-params(14));
  g1(3, 1)=  g1(3, 1)+1;
  g1(3, 2)=  g1(3, 2)+1;
  g1(3, 3)=  g1(3, 3)+(-1);
  g1(4, 1)=  g1(4, 1)+(-1);
  g1(4, 2)=  g1(4, 2)+(-1);
  g1(4, 5)=  g1(4, 5)+(-1);
  g1(4, 2)=  g1(4, 2)+1;
  g1(4, 1)=  g1(4, 1)+1;
  g1(4, 7)=  g1(4, 7)+1;
  g1(5, 4)=  g1(5, 4)+1;
  g1(5, 1)=  g1(5, 1)+(-(1-params(4)));
  g1(5, 3)=  g1(5, 3)+(-params(4));
  g1(5, 6)=  g1(5, 6)+(-(1-params(4)));
  g1(6, 2)=  g1(6, 2)+(-(1+params(5)*params(15)));
  g1(6, 2)=  g1(6, 2)+1+params(5)*params(15);
  g1(6, 8)=  g1(6, 8)+params(15)-params(3)*params(15)*(1-params(5))*(-(1-params(5)));
  g1(6, 8)=  g1(6, 8)+params(15)*(-(1-params(5)));
  g1(6, 6)=  g1(6, 6)+(-(params(3)*params(7)));
  g1(6, 8)=  g1(6, 8)+(-(params(3)*params(15)*(1-params(5))));
  g1(7, 1)=  g1(7, 1)+1;
  g1(7, 2)=  g1(7, 2)+1;
  g1(7, 5)=  g1(7, 5)+(-(params(6)/params(3)));
  g1(8, 7)=  g1(8, 7)+1;
  g1(8, 7)=  g1(8, 7)+(-params(2));
  g1(9, 2)=  g1(9, 2)+params(10);
  g1(9, 8)=  g1(9, 8)+params(9);
  g1(9, 8)=  g1(9, 8)+(-((1-params(5))*params(9)));
  g1(9, 9)=  g1(9, 9)+(-1);
  g1(10, 4)=  g1(10, 4)+1;
  g1(10, 3)=  g1(10, 3)+(-1);
  g1(10, 9)=  g1(10, 9)+1;
  g1(10, 10)=  g1(10, 10)+(-1);
  g1(11, 4)=  g1(11, 4)+1;
  g1(11, 1)=  g1(11, 1)+(-1);
  g1(11, 6)=  g1(11, 6)+(-1);
  g1(11, 8)=  g1(11, 8)+(-1);
  g1(11, 9)=  g1(11, 9)+1;
  g1(12, 8)=  g1(12, 8)+(-(1/params(5)));
  g1(12, 8)=  g1(12, 8)+(-(1/params(5)*(-(1-params(5)))));
  g1(12, 12)=  g1(12, 12)+1;
  if ~isreal(g1)
    g1 = real(g1)+2*imag(g1);
  end
end
