function [residual, g1, g2, g3] = equilibrium_dynare_dynamic(y, x, params, it_)
%
% Status : Computes dynamic model for Dynare
%
% Warning : this file is generated automatically by Dynare
%           from model file (.mod)

%
% Model equations
%

residual = zeros(13, 1);
lhs =y(6);
rhs =params(12)*y(1)+params(13)*y(2)+params(14)*y(13);
residual(1)= lhs-rhs;
lhs =y(9);
rhs =y(10)-y(6);
residual(2)= lhs-rhs;
lhs =0;
rhs =y(6)+y(9)+y(11)-y(20)-y(18)-y(22);
residual(3)= lhs-rhs;
lhs =y(8);
rhs =y(10)*params(4)+y(6)*(1-params(4))+(1-params(4))*y(12);
residual(4)= lhs-rhs;
lhs =(y(20)-y(9))*(1+params(5)*params(11))+params(11)*(y(5)-y(1)*(1-params(5)));
rhs =params(3)*(params(7)*y(21)+params(11)*(1-params(5))*(y(17)-y(5)*(1-params(5))));
residual(5)= lhs-rhs;
lhs =y(6)+y(9);
rhs =y(11)*params(6)/params(3);
residual(6)= lhs-rhs;
lhs =y(13);
rhs =params(2)*y(3)+x(it_, 1);
residual(7)= lhs-rhs;
lhs =y(9)*params(10)+y(5)*params(9)-y(1)*(1-params(5))*params(9);
rhs =y(14);
residual(8)= lhs-rhs;
lhs =y(8)+y(14)-y(15);
rhs =y(10);
residual(9)= lhs-rhs;
lhs =y(8)+y(14)-y(1);
rhs =y(6)+y(12);
residual(10)= lhs-rhs;
lhs =y(4);
rhs =y(8)-y(6);
residual(11)= lhs-rhs;
lhs =y(7);
rhs =y(22)+y(19)-y(8);
residual(12)= lhs-rhs;
lhs =y(16);
rhs =(y(5)-y(1)*(1-params(5)))*1/params(5);
residual(13)= lhs-rhs;
if nargout >= 2,
  g1 = zeros(13, 23);

%
% Jacobian matrix
%

  g1(1, 6)=  g1(1, 6)+1;
  g1(1, 1)=  g1(1, 1)+(-params(12));
  g1(1, 2)=  g1(1, 2)+(-params(13));
  g1(1, 13)=  g1(1, 13)+(-params(14));
  g1(2, 6)=  g1(2, 6)+1;
  g1(2, 9)=  g1(2, 9)+1;
  g1(2, 10)=  g1(2, 10)+(-1);
  g1(3, 6)=  g1(3, 6)+(-1);
  g1(3, 9)=  g1(3, 9)+(-1);
  g1(3, 11)=  g1(3, 11)+(-1);
  g1(3, 20)=  g1(3, 20)+1;
  g1(3, 18)=  g1(3, 18)+1;
  g1(3, 22)=  g1(3, 22)+1;
  g1(4, 6)=  g1(4, 6)+(-(1-params(4)));
  g1(4, 10)=  g1(4, 10)+(-params(4));
  g1(4, 8)=  g1(4, 8)+1;
  g1(4, 12)=  g1(4, 12)+(-(1-params(4)));
  g1(5, 1)=  g1(5, 1)+params(11)*(-(1-params(5)));
  g1(5, 9)=  g1(5, 9)+(-(1+params(5)*params(11)));
  g1(5, 20)=  g1(5, 20)+1+params(5)*params(11);
  g1(5, 5)=  g1(5, 5)+params(11)-params(3)*params(11)*(1-params(5))*(-(1-params(5)));
  g1(5, 21)=  g1(5, 21)+(-(params(3)*params(7)));
  g1(5, 17)=  g1(5, 17)+(-(params(3)*params(11)*(1-params(5))));
  g1(6, 6)=  g1(6, 6)+1;
  g1(6, 9)=  g1(6, 9)+1;
  g1(6, 11)=  g1(6, 11)+(-(params(6)/params(3)));
  g1(7, 13)=  g1(7, 13)+1;
  g1(7, 3)=  g1(7, 3)+(-params(2));
  g1(7, 23)=  g1(7, 23)+(-1);
  g1(8, 1)=  g1(8, 1)+(-((1-params(5))*params(9)));
  g1(8, 9)=  g1(8, 9)+params(10);
  g1(8, 5)=  g1(8, 5)+params(9);
  g1(8, 14)=  g1(8, 14)+(-1);
  g1(9, 10)=  g1(9, 10)+(-1);
  g1(9, 8)=  g1(9, 8)+1;
  g1(9, 14)=  g1(9, 14)+1;
  g1(9, 15)=  g1(9, 15)+(-1);
  g1(10, 6)=  g1(10, 6)+(-1);
  g1(10, 1)=  g1(10, 1)+(-1);
  g1(10, 8)=  g1(10, 8)+1;
  g1(10, 12)=  g1(10, 12)+(-1);
  g1(10, 14)=  g1(10, 14)+1;
  g1(11, 6)=  g1(11, 6)+1;
  g1(11, 8)=  g1(11, 8)+(-1);
  g1(11, 4)=  g1(11, 4)+1;
  g1(12, 22)=  g1(12, 22)+(-1);
  g1(12, 8)=  g1(12, 8)+1;
  g1(12, 7)=  g1(12, 7)+1;
  g1(12, 19)=  g1(12, 19)+(-1);
  g1(13, 1)=  g1(13, 1)+(-(1/params(5)*(-(1-params(5)))));
  g1(13, 5)=  g1(13, 5)+(-(1/params(5)));
  g1(13, 16)=  g1(13, 16)+1;
end
if nargout >= 3,
  g2 = sparse([],[],[], 13, 529, 2645);

%
% Hessian matrix
%

end;
