%
% Status : main Dynare file 
%
% Warning : this file is generated automatically by Dynare
%           from model file (.mod)

clear all
tic;
global M_ oo_ exedet_ exdet_ recur_ recurs_ 
global options_ endval_
global ys0_ recurs0_ ex0_ ct_
options_ = [];
M_.fname = 'equilibrium_dynare_nonlinear';
%
% Some global variables initialization
%
global_initialization;
diary off;
warning_old_state = warning;
warning off;
delete equilibrium_dynare_nonlinear.log;
warning warning_old_state
logname_ = 'equilibrium_dynare_nonlinear.log';
diary equilibrium_dynare_nonlinear.log
options_.model_mode = 0;
erase_compiled_function('equilibrium_dynare_nonlinear_static');
erase_compiled_function('equilibrium_dynare_nonlinear_dynamic');
M_.exo_names = 'eps';
M_.exo_names_tex = '';
M_.endo_names = 'p';
M_.endo_names_tex = '';
M_.endo_names = strvcat(M_.endo_names, 'c');
M_.endo_names_tex = strvcat(M_.endo_names_tex, '');
M_.endo_names = strvcat(M_.endo_names, 'w');
M_.endo_names_tex = strvcat(M_.endo_names_tex, '');
M_.endo_names = strvcat(M_.endo_names, 'omega');
M_.endo_names_tex = strvcat(M_.endo_names_tex, '');
M_.endo_names = strvcat(M_.endo_names, 'r');
M_.endo_names_tex = strvcat(M_.endo_names_tex, '');
M_.endo_names = strvcat(M_.endo_names, 'rk');
M_.endo_names_tex = strvcat(M_.endo_names_tex, '');
M_.endo_names = strvcat(M_.endo_names, 'g');
M_.endo_names_tex = strvcat(M_.endo_names_tex, '');
M_.endo_names = strvcat(M_.endo_names, 'k');
M_.endo_names_tex = strvcat(M_.endo_names_tex, '');
M_.endo_names = strvcat(M_.endo_names, 'y');
M_.endo_names_tex = strvcat(M_.endo_names_tex, '');
M_.endo_names = strvcat(M_.endo_names, 'l');
M_.endo_names_tex = strvcat(M_.endo_names_tex, '');
M_.param_names = 'lambda';
M_.param_names_tex = '';
M_.param_names = strvcat(M_.param_names, 'gamma');
M_.param_names_tex = strvcat(M_.param_names_tex, '');
M_.param_names = strvcat(M_.param_names, 'rhom');
M_.param_names_tex = strvcat(M_.param_names_tex, '');
M_.param_names = strvcat(M_.param_names, 'beta');
M_.param_names_tex = strvcat(M_.param_names_tex, '');
M_.param_names = strvcat(M_.param_names, 'alpha');
M_.param_names_tex = strvcat(M_.param_names_tex, '');
M_.param_names = strvcat(M_.param_names, 'delta');
M_.param_names_tex = strvcat(M_.param_names_tex, '');
M_.param_names = strvcat(M_.param_names, 'eta');
M_.param_names_tex = strvcat(M_.param_names_tex, '');
M_.param_names = strvcat(M_.param_names, 'rbar');
M_.param_names_tex = strvcat(M_.param_names_tex, '');
M_.param_names = strvcat(M_.param_names, 'cw');
M_.param_names_tex = strvcat(M_.param_names_tex, '');
M_.param_names = strvcat(M_.param_names, 'kybar');
M_.param_names_tex = strvcat(M_.param_names_tex, '');
M_.param_names = strvcat(M_.param_names, 'cybar');
M_.param_names_tex = strvcat(M_.param_names_tex, '');
M_.exo_det_nbr = 0;
M_.exo_nbr = 1;
M_.endo_nbr = 10;
M_.recur_nbr = 0;
M_.param_nbr = 11;
M_.Sigma_e = zeros(1, 1);
options_.linear = 1;
M_.lead_lag_incidence = [
	 0 3 13;
	 0 4 14;
	 0 5 0;
	 0 6 0;
	 0 7 0;
	 0 8 15;
	 1 9 16;
	 2 10 0;
	 0 11 0;
	 0 12 0;]';
M_.exo_names_orig_ord = [1:1];
M_.maximum_lag = 1;
M_.maximum_lead = 1;
M_.maximum_endo_lag = 1;
M_.maximum_endo_lead = 1;
oo_.steady_state = zeros(10, 1);
M_.maximum_exo_lag = 0;
M_.maximum_exo_lead = 0;
oo_.exo_steady_state = zeros(1, 1);
M_.params = repmat(NaN,11, 1);
M_.params( 4 ) = 0.9966039468010824;
beta = M_.params( 4 );
M_.params( 2 ) = 3;
gamma = M_.params( 2 );
M_.params( 3 ) = 0.61;
rhom = M_.params( 3 );
se     = 0.0018;
M_.params( 5 ) = 0.67;
alpha = M_.params( 5 );
M_.params( 6 ) = 0.01;
delta = M_.params( 6 );
M_.params( 8 ) = 1/M_.params(4)-1+M_.params(6);
rbar = M_.params( 8 );
M_.params( 9 ) = M_.params(5)^M_.params(5)*(1-M_.params(5))^(1-M_.params(5));
cw = M_.params( 9 );
M_.params( 10 ) = (1-M_.params(5))*M_.params(9)*(M_.params(2)-1)/M_.params(2)/(1/M_.params(4)-1+M_.params(6));
kybar = M_.params( 10 );
M_.params( 11 ) = 1-M_.params(6)*M_.params(10);
cybar = M_.params( 11 );
M_.params( 7 ) = 1.9;
eta = M_.params( 7 );
%
% SHOCKS instructions
%
make_ex_;
M_.exo_det_length = 0;
M_.Sigma_e(1, 1) = se^2;
%
% INITVAL instructions
%
options_.initval_file = 0;
endval_=0;
oo_.steady_state( 5 ) = log(1/M_.params(4));
oo_.steady_state( 6 ) = log(1/M_.params(4)-1+M_.params(6));
oo_.steady_state( 3 ) = M_.params(7)*log(1-M_.params(4));
oo_.steady_state( 4 ) = (1-M_.params(5))/M_.params(5)*log(M_.params(2)/(M_.params(2)-1))+oo_.steady_state(3)+(1-M_.params(5))/M_.params(5)*oo_.steady_state(6);
oo_.steady_state( 1 ) = log(M_.params(2)/(M_.params(2)-1))+oo_.steady_state(4);
oo_.steady_state( 2 ) = oo_.steady_state(3)-oo_.steady_state(1);
oo_.steady_state( 8 ) = log((1-M_.params(5))*M_.params(9)*exp(oo_.steady_state(2))/(exp(oo_.steady_state(6)+oo_.steady_state(1)-oo_.steady_state(4))-M_.params(6)*(1-M_.params(5))*M_.params(9)));
oo_.steady_state( 9 ) = log(exp(oo_.steady_state(2))+M_.params(6)*exp(oo_.steady_state(8)));
oo_.steady_state( 10 ) = log(M_.params(5)*M_.params(9)*exp(oo_.steady_state(4)+oo_.steady_state(9)-oo_.steady_state(3)));
oo_.steady_state( 7 ) = 0;
oo_.endo_simul=[oo_.steady_state*ones(1,M_.maximum_lag)];
if M_.exo_nbr > 0;
	oo_.exo_simul = [ones(M_.maximum_lag,1)*oo_.exo_steady_state'];
end;
if M_.exo_det_nbr > 0;
	oo_.exo_det_simul = [ones(M_.maximum_lag,1)*oo_.exo_det_steady_state'];
end;
steady;
var_list_=[];
info = stoch_simul(var_list_);
save('equilibrium_dynare_nonlinear_results.mat', 'oo_', 'M_', 'options_');
diary off

disp(['Total computing time : ' dynsec2hms(toc) ]);
