function [residual, g1, g2, g3] = equilibrium_dynare_nonlinear_dynamic(y, x, params, it_)
%
% Status : Computes dynamic model for Dynare
%
% Warning : this file is generated automatically by Dynare
%           from model file (.mod)

%
% Model equations
%

residual = zeros(10, 1);
T15 = params(4)*exp(y(7))*exp(y(4))/exp(y(14))*exp(y(3));
T43 = exp(y(5))^params(5);
T48 = (exp(y(3))*exp(y(8)))^(1-params(5));
T79 = exp(y(6))*params(5)*params(9)*exp(y(11)-y(12));
T85 = params(9)*exp(y(6))*(1-params(5))*exp(y(11)-y(2));
T93 = exp(y(13))*exp(y(3))*params(4)*exp(y(7))*exp(y(4))*exp(y(14))/(exp(y(14))*exp(y(14)));
T94 = exp(y(13))*exp(y(13));
T97 = exp(y(16))*exp(y(16));
T99 = (-(exp(y(16))*T93/T94/T97));
T109 = exp(y(13))*exp(y(3))*(-(params(4)*exp(y(7))*exp(y(4))*exp(y(14))))/(exp(y(14))*exp(y(14)));
T128 = exp(y(3))*exp(y(8))*(1-params(5))*(exp(y(3))*exp(y(8)))^(1-params(5)-1);
T130 = (-(T43*T128));
T138 = (-(T15/exp(y(13))*exp(y(16))));
T149 = exp(y(5))*params(5)*exp(y(5))^(params(5)-1);
T172 = (-(T97*exp(y(16))*T94*exp(y(13))*exp(y(3))*params(4)*exp(y(7))*exp(y(4))*exp(y(14))*exp(y(14))*exp(y(14))/(exp(y(14))*exp(y(14))*exp(y(14))*exp(y(14)))/(T94*T94)/(T97*T97)));
T182 = (-(T97*exp(y(16))*T94*exp(y(13))*exp(y(3))*exp(y(14))*exp(y(14))*(-(params(4)*exp(y(7))*exp(y(4))*exp(y(14))))/(exp(y(14))*exp(y(14))*exp(y(14))*exp(y(14)))/(T94*T94)/(T97*T97)));
T200 = (-(T97*exp(y(16))*T93*T94/(T94*T94)/(T97*T97)));
T219 = (-(T97*exp(y(16))*T94*(-T93)/(T94*T94)/(T97*T97)));
T244 = (-(T97*(-(exp(y(16))*T93/T94))/(T97*T97)));
T296 = (-(T43*(T128+exp(y(3))*exp(y(8))*(1-params(5))*exp(y(3))*exp(y(8))*(1-params(5)-1)*(exp(y(3))*exp(y(8)))^(1-params(5)-1-1))));
lhs =1;
rhs =T15/exp(y(13))/exp(y(16));
residual(1)= lhs-rhs;
lhs =exp(y(14))/exp(y(4));
rhs =params(4)*(exp(y(15))+1-params(6));
residual(2)= lhs-rhs;
lhs =exp(y(3));
rhs =params(2)/(params(2)-1)*exp(y(6));
residual(3)= lhs-rhs;
lhs =exp(y(4));
rhs =exp(y(5))/exp(y(3));
residual(4)= lhs-rhs;
lhs =exp(y(6));
rhs =T43*T48;
residual(5)= lhs-rhs;
lhs =y(4)+y(3);
rhs =params(7)*(exp(y(7))-1);
residual(6)= lhs-rhs;
lhs =y(9);
rhs =params(3)*y(1)+x(it_, 1);
residual(7)= lhs-rhs;
lhs =exp(y(4))+exp(y(10))-(1-params(6))*exp(y(2));
rhs =exp(y(11));
residual(8)= lhs-rhs;
lhs =T79;
rhs =exp(y(5));
residual(9)= lhs-rhs;
lhs =T85;
rhs =exp(y(3)+y(8));
residual(10)= lhs-rhs;
if nargout >= 2,
  g1 = zeros(10, 17);

%
% Jacobian matrix
%

  g1(1, 7)=  g1(1, 7)+T99;
  g1(1, 4)=  g1(1, 4)+T99;
  g1(1, 14)=  g1(1, 14)+(-(exp(y(16))*T109/T94/T97));
  g1(1, 3)=  g1(1, 3)+(-(exp(y(16))*T15*exp(y(13))/T94/T97));
  g1(1, 13)=  g1(1, 13)+(-(exp(y(16))*(-(T15*exp(y(13))))/T94/T97));
  g1(1, 16)=  g1(1, 16)+(-(T138/T97));
  g1(2, 4)=  g1(2, 4)+(-(exp(y(4))*exp(y(14))))/(exp(y(4))*exp(y(4)));
  g1(2, 14)=  g1(2, 14)+exp(y(4))*exp(y(14))/(exp(y(4))*exp(y(4)));
  g1(2, 15)=  g1(2, 15)+(-(params(4)*exp(y(15))));
  g1(3, 3)=  g1(3, 3)+exp(y(3));
  g1(3, 6)=  g1(3, 6)+(-(params(2)/(params(2)-1)*exp(y(6))));
  g1(4, 4)=  g1(4, 4)+exp(y(4));
  g1(4, 3)=  g1(4, 3)+(-((-(exp(y(3))*exp(y(5))))/(exp(y(3))*exp(y(3)))));
  g1(4, 5)=  g1(4, 5)+(-(exp(y(3))*exp(y(5))/(exp(y(3))*exp(y(3)))));
  g1(5, 3)=  g1(5, 3)+T130;
  g1(5, 6)=  g1(5, 6)+exp(y(6));
  g1(5, 5)=  g1(5, 5)+(-(T48*T149));
  g1(5, 8)=  g1(5, 8)+T130;
  g1(6, 7)=  g1(6, 7)+(-(exp(y(7))*params(7)));
  g1(6, 4)=  g1(6, 4)+1;
  g1(6, 3)=  g1(6, 3)+1;
  g1(7, 9)=  g1(7, 9)+1;
  g1(7, 1)=  g1(7, 1)+(-params(3));
  g1(7, 17)=  g1(7, 17)+(-1);
  g1(8, 4)=  g1(8, 4)+exp(y(4));
  g1(8, 10)=  g1(8, 10)+exp(y(10));
  g1(8, 2)=  g1(8, 2)+(-((1-params(6))*exp(y(2))));
  g1(8, 11)=  g1(8, 11)+(-exp(y(11)));
  g1(9, 6)=  g1(9, 6)+T79;
  g1(9, 5)=  g1(9, 5)+(-exp(y(5)));
  g1(9, 11)=  g1(9, 11)+T79;
  g1(9, 12)=  g1(9, 12)+exp(y(6))*params(5)*params(9)*(-exp(y(11)-y(12)));
  g1(10, 3)=  g1(10, 3)+(-exp(y(3)+y(8)));
  g1(10, 6)=  g1(10, 6)+T85;
  g1(10, 8)=  g1(10, 8)+(-exp(y(3)+y(8)));
  g1(10, 2)=  g1(10, 2)+params(9)*exp(y(6))*(1-params(5))*(-exp(y(11)-y(2)));
  g1(10, 11)=  g1(10, 11)+T85;
end
if nargout >= 3,
  g2 = sparse([],[],[], 10, 289, 1445);

%
% Hessian matrix
%

  g2(1, 109) = T172;
  g2(1, 58) = T172;
  g2(1, 55) = T172;
  g2(1, 228) = T182;
  g2(1, 225) = T182;
  g2(1, 235) = (-(T97*exp(y(16))*T94*exp(y(13))*exp(y(3))*(exp(y(14))*exp(y(14))*(-(params(4)*exp(y(7))*exp(y(4))*exp(y(14))))-(-(params(4)*exp(y(7))*exp(y(4))*exp(y(14))))*(exp(y(14))*exp(y(14))+exp(y(14))*exp(y(14))))/(exp(y(14))*exp(y(14))*exp(y(14))*exp(y(14)))/(T94*T94)/(T97*T97)));
  g2(1, 41) = T200;
  g2(1, 38) = T200;
  g2(1, 48) = (-(T97*exp(y(16))*T94*T109/(T94*T94)/(T97*T97)));
  g2(1, 37) = (-(T97*exp(y(16))*T94*T15*exp(y(13))/(T94*T94)/(T97*T97)));
  g2(1, 211) = T219;
  g2(1, 208) = T219;
  g2(1, 218) = (-(T97*exp(y(16))*T94*(-T109)/(T94*T94)/(T97*T97)));
  g2(1, 207) = (-(T97*exp(y(16))*T94*(-(T15*exp(y(13))))/(T94*T94)/(T97*T97)));
  g2(1, 217) = (-(T97*exp(y(16))*(T94*(-(T15*exp(y(13))))-(-(T15*exp(y(13))))*(T94+T94))/(T94*T94)/(T97*T97)));
  g2(1, 262) = T244;
  g2(1, 259) = T244;
  g2(1, 269) = (-(T97*(-(exp(y(16))*T109/T94))/(T97*T97)));
  g2(1, 258) = (-(T97*(-(exp(y(16))*T15*exp(y(13))/T94))/(T97*T97)));
  g2(1, 268) = (-(T97*(-(exp(y(16))*(-(T15*exp(y(13))))/T94))/(T97*T97)));
  g2(1, 271) = (-((T97*T138-T138*(T97+T97))/(T97*T97)));
  g2(2, 55) = ((-(exp(y(4))*exp(y(14))))*exp(y(4))*exp(y(4))-(-(exp(y(4))*exp(y(14))))*(exp(y(4))*exp(y(4))+exp(y(4))*exp(y(4))))/(exp(y(4))*exp(y(4))*exp(y(4))*exp(y(4)));
  g2(2, 225) = (exp(y(4))*exp(y(14))*exp(y(4))*exp(y(4))-exp(y(4))*exp(y(14))*(exp(y(4))*exp(y(4))+exp(y(4))*exp(y(4))))/(exp(y(4))*exp(y(4))*exp(y(4))*exp(y(4)));
  g2(2, 235) = exp(y(4))*exp(y(14))*exp(y(4))*exp(y(4))/(exp(y(4))*exp(y(4))*exp(y(4))*exp(y(4)));
  g2(2, 253) = (-(params(4)*exp(y(15))));
  g2(3, 37) = exp(y(3));
  g2(3, 91) = (-(params(2)/(params(2)-1)*exp(y(6))));
  g2(4, 55) = exp(y(4));
  g2(4, 37) = (-(((-(exp(y(3))*exp(y(5))))*exp(y(3))*exp(y(3))-(-(exp(y(3))*exp(y(5))))*(exp(y(3))*exp(y(3))+exp(y(3))*exp(y(3))))/(exp(y(3))*exp(y(3))*exp(y(3))*exp(y(3)))));
  g2(4, 71) = (-((exp(y(3))*exp(y(5))*exp(y(3))*exp(y(3))-exp(y(3))*exp(y(5))*(exp(y(3))*exp(y(3))+exp(y(3))*exp(y(3))))/(exp(y(3))*exp(y(3))*exp(y(3))*exp(y(3)))));
  g2(4, 73) = (-(exp(y(3))*exp(y(5))*exp(y(3))*exp(y(3))/(exp(y(3))*exp(y(3))*exp(y(3))*exp(y(3)))));
  g2(5, 37) = T296;
  g2(5, 91) = exp(y(6));
  g2(5, 71) = (-(T128*T149));
  g2(5, 73) = (-(T48*(T149+exp(y(5))*params(5)*exp(y(5))*(params(5)-1)*exp(y(5))^(params(5)-1-1))));
  g2(5, 122) = T296;
  g2(5, 124) = (-(T128*T149));
  g2(5, 127) = T296;
  g2(6, 109) = (-(exp(y(7))*params(7)));
  g2(8, 55) = exp(y(4));
  g2(8, 163) = exp(y(10));
  g2(8, 19) = (-((1-params(6))*exp(y(2))));
  g2(8, 181) = (-exp(y(11)));
  g2(9, 91) = T79;
  g2(9, 73) = (-exp(y(5)));
  g2(9, 176) = T79;
  g2(9, 181) = T79;
  g2(9, 193) = exp(y(6))*params(5)*params(9)*(-exp(y(11)-y(12)));
  g2(9, 198) = exp(y(6))*params(5)*params(9)*(-exp(y(11)-y(12)));
  g2(9, 199) = T79;
  g2(10, 37) = (-exp(y(3)+y(8)));
  g2(10, 91) = T85;
  g2(10, 122) = (-exp(y(3)+y(8)));
  g2(10, 127) = (-exp(y(3)+y(8)));
  g2(10, 23) = params(9)*exp(y(6))*(1-params(5))*(-exp(y(11)-y(2)));
  g2(10, 19) = T85;
  g2(10, 176) = T85;
  g2(10, 172) = params(9)*exp(y(6))*(1-params(5))*(-exp(y(11)-y(2)));
  g2(10, 181) = T85;
  g2(1, 106) = g2(1, 58);
  g2(1, 116) = g2(1, 228);
  g2(1, 65) = g2(1, 225);
  g2(1, 105) = g2(1, 41);
  g2(1, 54) = g2(1, 38);
  g2(1, 224) = g2(1, 48);
  g2(1, 115) = g2(1, 211);
  g2(1, 64) = g2(1, 208);
  g2(1, 234) = g2(1, 218);
  g2(1, 47) = g2(1, 207);
  g2(1, 118) = g2(1, 262);
  g2(1, 67) = g2(1, 259);
  g2(1, 237) = g2(1, 269);
  g2(1, 50) = g2(1, 258);
  g2(1, 220) = g2(1, 268);
  g2(2, 65) = g2(2, 225);
  g2(4, 39) = g2(4, 71);
  g2(5, 39) = g2(5, 71);
  g2(5, 42) = g2(5, 122);
  g2(5, 76) = g2(5, 124);
  g2(9, 96) = g2(9, 176);
  g2(9, 97) = g2(9, 193);
  g2(9, 182) = g2(9, 198);
  g2(10, 42) = g2(10, 122);
  g2(10, 87) = g2(10, 23);
  g2(10, 96) = g2(10, 176);
  g2(10, 28) = g2(10, 172);
end;
