disp('simulating...');
T = 100;
N = 10000;

mu1  = zeros(N,T);
mu2  = zeros(N,T);
Fadj = zeros(T,1);

tshock = 51;
mshock = 0.01*(1-rog);

M = ones(T,1);
g = zeros(T,1);
eg = zeros(T,1);
eg(tshock) = 0;

randn('state',0);
rand('state',0);


for t = 1:T

    if t==1
        
                
shock = randn(N,2);
shock = sa*(1-2*ha)^(3/4)*shock.*exp(ha.*shock.^2/2);  

shock = shock.*(rand(N,2)<pshock);
meane=mean(shock,2);
shock(:,1)=shock(:,1)+saa*meane;
shock(:,2)=shock(:,2)+saa*meane;

        ea = shock;
        
        state = [gamma/(gamma-1)*ones(N,1),gamma/(gamma-1)*ones(N,1)];
        
        x = gamma/(gamma-1)*ones(N,2);        
                
        v1 = valfunc1(c,fspace,state,x,e,w);
        v2 = valfunc2(c,fspace,state,[],e,w);
       
        % indicators for choice of action
        
        R=(v1>=v2);
        
        mu1(:,t) = x(:,1).*(R) + state(:,1).*(~R);
        mu2(:,t) = x(:,2).*(R) + state(:,2).*(~R);
        
    else

          
shock = randn(N,2);
shock = sa*(1-2*ha)^(3/4)*shock.*exp(ha.*shock.^2/2);  

shock = shock.*(rand(N,2)<pshock);
meane=mean(shock,2);
shock(:,1)=shock(:,1)+saa*meane;
shock(:,2)=shock(:,2)+saa*meane;

        ea = shock;

        g(t)   = rog*g(t-1)+eg(t);
        M(t)   = M(t-1)*exp(g(t));
                
        state = [mu1(:,t-1).*exp(ea(:,1)+mua)/exp(g(t)),mu2(:,t-1).*exp(ea(:,1)+mua)/exp(g(t))];
        
        x = gamma/(gamma-1)*ones(N,2);        
                
        v1 = valfunc1(c,fspace,state,x,e,w);
        v2 = valfunc2(c,fspace,state,[],e,w);
       
        % indicators for choice of action
        
        R=(v1>=v2);
        
        mu1(:,t) = x(:,1).*(R) + state(:,1).*(~R);
        mu2(:,t) = x(:,2).*(R) + state(:,2).*(~R);
        
        Fadj(t)=mean(R);
    end
end

   mu1(:,1:30)=[];
   mu2(:,1:30)=[];
   M(1:30)=[];

   P1 = (mean(mu1.^(1-gamma)).^(1/(1-gamma)))'.*M;
   P2 = (mean(mu2.^(1-gamma)).^(1/(1-gamma)))'.*M;
   
   P = (1/2*P1.^(1-theta)+1/2*P2.^(1-theta)).^(1/(1-theta));

   Pf = P;
   P1f = P1;
   P2f = P2;
   Fadjf = Fadj;
   
   clear mu1 mu2 
   
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  WITH MONEY SHOCK %%%%%%%%%%%%%%%
   
mu1  = zeros(N,T);
mu2  = zeros(N,T);
Fadj = zeros(T,1);

tshock = 51;

M = ones(T,1);
g = zeros(T,1);
eg = zeros(T,1);
eg(tshock) = mshock;

randn('state',0);
rand('state',0);

for t = 1:T

    if t==1
        
          
shock = randn(N,2);
shock = sa*(1-2*ha)^(3/4)*shock.*exp(ha.*shock.^2/2);  

shock = shock.*(rand(N,2)<pshock);
meane=mean(shock,2);
shock(:,1)=shock(:,1)+saa*meane;
shock(:,2)=shock(:,2)+saa*meane;

        ea = shock;
        
        state = [gamma/(gamma-1)*ones(N,1),gamma/(gamma-1)*ones(N,1)];
        
        x = gamma/(gamma-1)*ones(N,2);        
                
        v1 = valfunc1(c,fspace,state,x,e,w);
        v2 = valfunc2(c,fspace,state,[],e,w);
       
        % indicators for choice of action
        
        R=(v1>=v2);
        
        mu1(:,t) = x(:,1).*(R) + state(:,1).*(~R);
        mu2(:,t) = x(:,2).*(R) + state(:,2).*(~R);
        
    else

          
shock = randn(N,2);
shock = sa*(1-2*ha)^(3/4)*shock.*exp(ha.*shock.^2/2);  

shock = shock.*(rand(N,2)<pshock);
meane=mean(shock,2);
shock(:,1)=shock(:,1)+saa*meane;
shock(:,2)=shock(:,2)+saa*meane;

        ea = shock;

        g(t)   = rog*g(t-1)+eg(t);
        M(t)   = M(t-1)*exp(g(t));
                
        state = [mu1(:,t-1).*exp(ea(:,1)+mua)/exp(g(t)),mu2(:,t-1).*exp(ea(:,2)+mua)/exp(g(t))];
        
        x = gamma/(gamma-1)*ones(N,2);        
                
        v1 = valfunc1(c,fspace,state,x,e,w);
        v2 = valfunc2(c,fspace,state,[],e,w);
       
        % indicators for choice of action
        
        R=(v1>=v2);
        
        mu1(:,t) = x(:,1).*(R) + state(:,1).*(~R);
        mu2(:,t) = x(:,2).*(R) + state(:,2).*(~R);
        
        Fadj(t)=mean(R);
    end
end

   mu1(:,1:30)=[];
   mu2(:,1:30)=[];
   M(1:30)=[];
   Fadj(1:30)=[];
   
   P1 = (mean(mu1.^(1-gamma)).^(1/(1-gamma)))'.*M;
   P2 = (mean(mu2.^(1-gamma)).^(1/(1-gamma)))'.*M;
   
   P = (1/2*P1.^(1-theta)+1/2*P2.^(1-theta)).^(1/(1-theta));

Cc = zeros(T,1);

lambda = 1-mean(Fadj);

AA = (1-beta*rog)/(1-lambda*beta*rog);

for t = 2:T
   
    Cc(t) = lambda*Cc(t-1) + lambda*AA*g(t);
    
end

   Cc(1:30)=[];
   
   C = log(M./P)-log(1./Pf);
   Ct = C;
   tshock = tshock-30;
   T = T-30;
   
   Ct(tshock+5:T-1) = 1/3*Ct(tshock+4:T-2)+1/3*Ct(tshock+5:T-1)+1/3*Ct(tshock+6:T);
   
   
   
   figure(1)
   plot(log(P/P(1))-log(Pf/Pf(1)));
   hold on
   plot(log(M/M(1)),'r')
   figure(2)
   plot([Ct,Cc])
   
   
   
