function [residual, g1, g2, g3] = equilibrium_dynare_calvo_dynamic(y, x, params, it_)
%
% Status : Computes dynamic model for Dynare
%
% Warning : this file is generated automatically by Dynare
%           from model file (.mod)

%
% Model equations
%

residual = zeros(16, 1);
T126 = (params(10)+params(5)*params(9))^(-1);
lhs =y(17);
rhs =params(15)*params(3)*y(26)+(1-params(15)*params(3))*y(8)+params(15)*params(3)*params(2)*y(13);
residual(1)= lhs-rhs;
lhs =y(6);
rhs =params(15)*(y(2)-y(13))+y(17)*(1-params(15));
residual(2)= lhs-rhs;
lhs =y(9);
rhs =y(10)-y(6);
residual(3)= lhs-rhs;
lhs =0;
rhs =y(6)+y(9)+y(11)-y(23)-y(21)-y(25);
residual(4)= lhs-rhs;
lhs =y(8);
rhs =y(10)*params(4)+y(6)*params(17)+params(17)*y(12)+y(6)*(1-params(4)-params(17));
residual(5)= lhs-rhs;
lhs =(y(23)-y(9))*(1+params(5)*params(16))+params(16)*(y(5)-(1-params(5))*y(1));
rhs =params(3)*(params(7)*y(24)+params(16)*(1-params(5))*(y(20)-y(5)*(1-params(5))));
residual(6)= lhs-rhs;
lhs =y(6)+y(9);
rhs =y(11)*params(6)/params(3);
residual(7)= lhs-rhs;
lhs =y(13);
rhs =params(2)*y(3)+x(it_, 1);
residual(8)= lhs-rhs;
lhs =y(9)*params(10)+y(5)*params(9)-y(1)*(1-params(5))*params(9)+params(11)*y(18);
rhs =y(14);
residual(9)= lhs-rhs;
lhs =y(8)+y(14)-y(15);
rhs =y(10);
residual(10)= lhs-rhs;
lhs =y(8)+y(14)-y(1);
rhs =y(6)+y(12);
residual(11)= lhs-rhs;
lhs =y(8)+y(14)-y(18);
rhs =y(6);
residual(12)= lhs-rhs;
lhs =y(4);
rhs =y(8)-y(6);
residual(13)= lhs-rhs;
lhs =y(7);
rhs =y(25)+y(22)-y(8);
residual(14)= lhs-rhs;
lhs =y(16);
rhs =(y(5)-(1-params(5))*y(1))*1/params(5);
residual(15)= lhs-rhs;
lhs =y(19);
rhs =(y(9)*params(10)+y(5)*params(9)-y(1)*(1-params(5))*params(9))*T126;
residual(16)= lhs-rhs;
if nargout >= 2,
  g1 = zeros(16, 27);

%
% Jacobian matrix
%

  g1(1, 17)=  g1(1, 17)+1;
  g1(1, 26)=  g1(1, 26)+(-(params(15)*params(3)));
  g1(1, 8)=  g1(1, 8)+(-(1-params(15)*params(3)));
  g1(1, 13)=  g1(1, 13)+(-(params(15)*params(3)*params(2)));
  g1(2, 17)=  g1(2, 17)+(-(1-params(15)));
  g1(2, 13)=  g1(2, 13)+params(15);
  g1(2, 6)=  g1(2, 6)+1;
  g1(2, 2)=  g1(2, 2)+(-params(15));
  g1(3, 6)=  g1(3, 6)+1;
  g1(3, 9)=  g1(3, 9)+1;
  g1(3, 10)=  g1(3, 10)+(-1);
  g1(4, 6)=  g1(4, 6)+(-1);
  g1(4, 9)=  g1(4, 9)+(-1);
  g1(4, 11)=  g1(4, 11)+(-1);
  g1(4, 23)=  g1(4, 23)+1;
  g1(4, 21)=  g1(4, 21)+1;
  g1(4, 25)=  g1(4, 25)+1;
  g1(5, 8)=  g1(5, 8)+1;
  g1(5, 6)=  g1(5, 6)+(-(params(17)+1-params(4)-params(17)));
  g1(5, 10)=  g1(5, 10)+(-params(4));
  g1(5, 12)=  g1(5, 12)+(-params(17));
  g1(6, 9)=  g1(6, 9)+(-(1+params(5)*params(16)));
  g1(6, 23)=  g1(6, 23)+1+params(5)*params(16);
  g1(6, 5)=  g1(6, 5)+params(16)-params(3)*params(16)*(1-params(5))*(-(1-params(5)));
  g1(6, 1)=  g1(6, 1)+params(16)*(-(1-params(5)));
  g1(6, 24)=  g1(6, 24)+(-(params(3)*params(7)));
  g1(6, 20)=  g1(6, 20)+(-(params(3)*params(16)*(1-params(5))));
  g1(7, 6)=  g1(7, 6)+1;
  g1(7, 9)=  g1(7, 9)+1;
  g1(7, 11)=  g1(7, 11)+(-(params(6)/params(3)));
  g1(8, 13)=  g1(8, 13)+1;
  g1(8, 3)=  g1(8, 3)+(-params(2));
  g1(8, 27)=  g1(8, 27)+(-1);
  g1(9, 9)=  g1(9, 9)+params(10);
  g1(9, 5)=  g1(9, 5)+params(9);
  g1(9, 1)=  g1(9, 1)+(-((1-params(5))*params(9)));
  g1(9, 18)=  g1(9, 18)+params(11);
  g1(9, 14)=  g1(9, 14)+(-1);
  g1(10, 8)=  g1(10, 8)+1;
  g1(10, 10)=  g1(10, 10)+(-1);
  g1(10, 14)=  g1(10, 14)+1;
  g1(10, 15)=  g1(10, 15)+(-1);
  g1(11, 8)=  g1(11, 8)+1;
  g1(11, 6)=  g1(11, 6)+(-1);
  g1(11, 12)=  g1(11, 12)+(-1);
  g1(11, 1)=  g1(11, 1)+(-1);
  g1(11, 14)=  g1(11, 14)+1;
  g1(12, 8)=  g1(12, 8)+1;
  g1(12, 6)=  g1(12, 6)+(-1);
  g1(12, 18)=  g1(12, 18)+(-1);
  g1(12, 14)=  g1(12, 14)+1;
  g1(13, 8)=  g1(13, 8)+(-1);
  g1(13, 6)=  g1(13, 6)+1;
  g1(13, 4)=  g1(13, 4)+1;
  g1(14, 8)=  g1(14, 8)+1;
  g1(14, 25)=  g1(14, 25)+(-1);
  g1(14, 7)=  g1(14, 7)+1;
  g1(14, 22)=  g1(14, 22)+(-1);
  g1(15, 5)=  g1(15, 5)+(-(1/params(5)));
  g1(15, 1)=  g1(15, 1)+(-(1/params(5)*(-(1-params(5)))));
  g1(15, 16)=  g1(15, 16)+1;
  g1(16, 9)=  g1(16, 9)+(-(params(10)*T126));
  g1(16, 5)=  g1(16, 5)+(-(params(9)*T126));
  g1(16, 1)=  g1(16, 1)+(-(T126*(-((1-params(5))*params(9)))));
  g1(16, 19)=  g1(16, 19)+1;
end
if nargout >= 3,
  g2 = sparse([],[],[], 16, 729, 3645);

%
% Hessian matrix
%

end;
