function [residual, g1, g2] = equilibrium_dynare_nonlinear_static(y, x, params)
%
% Status : Computes static model for Dynare
%
% Warning : this file is generated automatically by Dynare
%           from model file (.mod)

residual = zeros( 10, 1);

%
% Model equations
%

T15 = params(4)*exp(y(5))*exp(y(2))/exp(y(2))*exp(y(1));
T43 = exp(y(3))^params(5);
T48 = (exp(y(1))*exp(y(6)))^(1-params(5));
T79 = exp(y(4))*params(5)*params(9)*exp(y(9)-y(10));
T85 = params(9)*exp(y(4))*(1-params(5))*exp(y(9)-y(8));
T93 = exp(y(1))*exp(y(1))*params(4)*exp(y(5))*exp(y(2))*exp(y(2))/(exp(y(2))*exp(y(2)));
T94 = exp(y(1))*exp(y(1));
T97 = exp(y(7))*exp(y(7));
T99 = (-(exp(y(7))*T93/T94/T97));
T109 = exp(y(1))*exp(y(1))*(-(params(4)*exp(y(5))*exp(y(2))*exp(y(2))))/(exp(y(2))*exp(y(2)));
T128 = exp(y(1))*exp(y(6))*(1-params(5))*(exp(y(1))*exp(y(6)))^(1-params(5)-1);
T130 = (-(T43*T128));
T138 = (-(T15/exp(y(1))*exp(y(7))));
T149 = exp(y(3))*params(5)*exp(y(3))^(params(5)-1);
T172 = (-(T97*exp(y(7))*T94*exp(y(1))*exp(y(1))*params(4)*exp(y(5))*exp(y(2))*exp(y(2))*exp(y(2))*exp(y(2))/(exp(y(2))*exp(y(2))*exp(y(2))*exp(y(2)))/(T94*T94)/(T97*T97)));
T182 = (-(T97*exp(y(7))*T94*exp(y(1))*exp(y(1))*exp(y(2))*exp(y(2))*(-(params(4)*exp(y(5))*exp(y(2))*exp(y(2))))/(exp(y(2))*exp(y(2))*exp(y(2))*exp(y(2)))/(T94*T94)/(T97*T97)));
T200 = (-(T97*exp(y(7))*T93*T94/(T94*T94)/(T97*T97)));
T219 = (-(T97*exp(y(7))*T94*(-T93)/(T94*T94)/(T97*T97)));
T244 = (-(T97*(-(exp(y(7))*T93/T94))/(T97*T97)));
T296 = (-(T43*(T128+exp(y(1))*exp(y(6))*(1-params(5))*exp(y(1))*exp(y(6))*(1-params(5)-1)*(exp(y(1))*exp(y(6)))^(1-params(5)-1-1))));
lhs =1;
rhs =T15/exp(y(1))/exp(y(7));
residual(1)= lhs-rhs;
lhs =exp(y(2))/exp(y(2));
rhs =params(4)*(exp(y(6))+1-params(6));
residual(2)= lhs-rhs;
lhs =exp(y(1));
rhs =params(2)/(params(2)-1)*exp(y(4));
residual(3)= lhs-rhs;
lhs =exp(y(2));
rhs =exp(y(3))/exp(y(1));
residual(4)= lhs-rhs;
lhs =exp(y(4));
rhs =T43*T48;
residual(5)= lhs-rhs;
lhs =y(2)+y(1);
rhs =params(7)*(exp(y(5))-1);
residual(6)= lhs-rhs;
lhs =y(7);
rhs =params(3)*y(7)+x(1);
residual(7)= lhs-rhs;
lhs =exp(y(2))+exp(y(8))-(1-params(6))*exp(y(8));
rhs =exp(y(9));
residual(8)= lhs-rhs;
lhs =T79;
rhs =exp(y(3));
residual(9)= lhs-rhs;
lhs =T85;
rhs =exp(y(1)+y(6));
residual(10)= lhs-rhs;
if ~isreal(residual)
  residual = real(residual)+imag(residual).^2;
end
if nargout >= 2,
  g1 = zeros(10, 10);

%
% Jacobian matrix
%

  g1(1, 5)=  g1(1, 5)+T99;
  g1(1, 2)=  g1(1, 2)+T99;
  g1(1, 2)=  g1(1, 2)+(-(exp(y(7))*T109/T94/T97));
  g1(1, 1)=  g1(1, 1)+(-(exp(y(7))*T15*exp(y(1))/T94/T97));
  g1(1, 1)=  g1(1, 1)+(-(exp(y(7))*(-(T15*exp(y(1))))/T94/T97));
  g1(1, 7)=  g1(1, 7)+(-(T138/T97));
  g1(2, 2)=  g1(2, 2)+(-(exp(y(2))*exp(y(2))))/(exp(y(2))*exp(y(2)));
  g1(2, 2)=  g1(2, 2)+exp(y(2))*exp(y(2))/(exp(y(2))*exp(y(2)));
  g1(2, 6)=  g1(2, 6)+(-(params(4)*exp(y(6))));
  g1(3, 1)=  g1(3, 1)+exp(y(1));
  g1(3, 4)=  g1(3, 4)+(-(params(2)/(params(2)-1)*exp(y(4))));
  g1(4, 2)=  g1(4, 2)+exp(y(2));
  g1(4, 1)=  g1(4, 1)+(-((-(exp(y(1))*exp(y(3))))/(exp(y(1))*exp(y(1)))));
  g1(4, 3)=  g1(4, 3)+(-(exp(y(1))*exp(y(3))/(exp(y(1))*exp(y(1)))));
  g1(5, 1)=  g1(5, 1)+T130;
  g1(5, 4)=  g1(5, 4)+exp(y(4));
  g1(5, 3)=  g1(5, 3)+(-(T48*T149));
  g1(5, 6)=  g1(5, 6)+T130;
  g1(6, 5)=  g1(6, 5)+(-(exp(y(5))*params(7)));
  g1(6, 2)=  g1(6, 2)+1;
  g1(6, 1)=  g1(6, 1)+1;
  g1(7, 7)=  g1(7, 7)+1;
  g1(7, 7)=  g1(7, 7)+(-params(3));
  g1(8, 2)=  g1(8, 2)+exp(y(2));
  g1(8, 8)=  g1(8, 8)+exp(y(8));
  g1(8, 8)=  g1(8, 8)+(-((1-params(6))*exp(y(8))));
  g1(8, 9)=  g1(8, 9)+(-exp(y(9)));
  g1(9, 4)=  g1(9, 4)+T79;
  g1(9, 3)=  g1(9, 3)+(-exp(y(3)));
  g1(9, 9)=  g1(9, 9)+T79;
  g1(9, 10)=  g1(9, 10)+exp(y(4))*params(5)*params(9)*(-exp(y(9)-y(10)));
  g1(10, 1)=  g1(10, 1)+(-exp(y(1)+y(6)));
  g1(10, 4)=  g1(10, 4)+T85;
  g1(10, 6)=  g1(10, 6)+(-exp(y(1)+y(6)));
  g1(10, 8)=  g1(10, 8)+params(9)*exp(y(4))*(1-params(5))*(-exp(y(9)-y(8)));
  g1(10, 9)=  g1(10, 9)+T85;
  if ~isreal(g1)
    g1 = real(g1)+2*imag(g1);
  end
end
