disp('simulating...');
T = 650;
N = 2500;

mu1     = zeros(N,T);
mu2     = zeros(N,T);
muR1    = zeros(N,T);
muR2    = zeros(N,T);
p1      = zeros(N,T);
p2      = zeros(N,T);
pR1     = zeros(N,T);
pR2     = zeros(N,T);
a1      = zeros(N,T);
a2      = zeros(N,T);
z       = zeros(N,T);
muRold1 = zeros(N,T);
muRold2 = zeros(N,T);
M       = zeros(T,1);
g       = zeros(T,1);
FadjR   = zeros(T,1);
FadjP   = zeros(T,1);

randn('state',0);
rand('state',0);

ainit = zeros(N,2);
eg    = randn(T,1)*sshock;

for t = 1:T

    if t==1
        
shock = randn(N,2);
shock = sa*shock;  
 
shock = shock.*(rand(N,2)<pshock);
 
meane=mean(shock,2);
shock(:,1)=shock(:,1)+saa*meane;
shock(:,2)=shock(:,2)+saa*meane;
        
ea = shock;
ez    =   zbar*(rand(N,1)<alpha);
        
        a1(:,t) = ainit(:,1) + ea(:,1);    
        a2(:,t) = ainit(:,2) + ea(:,2);
        z(:,t)  = ez;
 
   g(t) = eg(t);
   M(t) = exp(g(t));
   
        state = [gamma/(gamma-1)*ones(N,1),gamma/(gamma-1)*ones(N,1),z(:,t),g(t)*ones(N,1)];
        
        state(:,1) = max(min(state(:,1),smax(1)),smin(1));
        state(:,2) = max(min(state(:,2),smax(2)),smin(2));
        
        xR = funeval(c_vx(:,4),fspace,state);
        xP = gamma/(gamma-1)*ones(N,1);
        
        v1 = valfunc1(c,fspace,state,xR,e,w);
        v2 = valfunc2(c,fspace,state,xP,e,w);
        v3 = valfunc3(c,fspace,state,[],e,w);
       
        % indicators for choice of action
        
        R1=(v1>=max([v1 v2 v3],[],2) |state(:,1)<=smin(1) |state(:,2)<=smin(2) | state(:,1)>=smax(1) |state(:,2)>=smax(2));
        R2=(v2>=max([v1 v2 v3],[],2) & R1==0);
        R3=(v3>=max([v1 v2 v3],[],2) & R1==0 & R2==0);
        
        muR1(:,t) = xR.*(R1) + state(:,1).*(~R1); 
        muR2(:,t) = xR.*(R1) + state(:,2).*(~R1);
        
        mu1(:,t) = xR.*(R1) + xP.*(R2) + state(:,1).*(R3);
        mu2(:,t) = xR.*(R1) + xP.*(R2) + state(:,2).*(R3);
        
        pR1(:,t) = muR1(:,t)./exp(a1(:,t))./exp(z(:,t))*M(t);
        pR2(:,t) = muR2(:,t)./exp(a2(:,t))./exp(z(:,t))*M(t);
        p1(:,t)  =  mu1(:,t)./exp(a1(:,t))./exp(z(:,t))*M(t);
        p2(:,t)  =  mu2(:,t)./exp(a2(:,t))./exp(z(:,t))*M(t);
        
        muRold1(:,t) = state(:,1);
        muRold2(:,t) = state(:,2);
        
        FadjR(t) = mean(R1);
        FadjP(t) = mean(R2);
        
    else

shock = randn(N,2);
shock = sa*shock;  
shock = shock.*(rand(N,2)<pshock);
meane = mean(shock,2);
shock(:,1)=shock(:,1)+saa*meane;
shock(:,2)=shock(:,2)+saa*meane;
        
ea = shock;
ez    =   zbar*(rand(N,1)<(alpha.*(z(:,t-1)==0)+rho.*(z(:,t-1)>0)));
               
        a1(:,t) = a1(:,t-1) + ea(:,1);
        a2(:,t) = a2(:,t-1) + ea(:,2);
        z(:,t)  = ez;
        
   g(t)   = rog*g(t-1)+eg(t);
   M(t)   = exp(g(t))*M(t-1);
        
        state = [muR1(:,t-1).*exp(a1(:,t)-a1(:,t-1)-g(t)).*exp(z(:,t)-z(:,t-1)),muR2(:,t-1).*exp(a2(:,t)-a2(:,t-1)-g(t)).*exp(z(:,t)-z(:,t-1)),z(:,t),g(t)*ones(N,1)];
        state(:,1) = max(min(state(:,1),smax(1)),smin(1));
        state(:,2) = max(min(state(:,2),smax(2)),smin(2));
        
        xR = funeval(c_vx(:,4),fspace,state);
        xP = gamma/(gamma-1)*ones(N,1);
        
        v1 = valfunc1(c,fspace,state,xR,e,w);
        v2 = valfunc2(c,fspace,state,xP,e,w);
        v3 = valfunc3(c,fspace,state,[],e,w);
       
        % indicators for choice of action
        
        R1=(v1>=max([v1 v2 v3],[],2) |state(:,1)<=smin(1) |state(:,2)<=smin(2) | state(:,1)>=smax(1) |state(:,2)>=smax(2));
        R2=(v2>=max([v1 v2 v3],[],2) & R1==0);
        R3=(v3>=max([v1 v2 v3],[],2) & R1==0 & R2==0);
        
        muR1(:,t) = xR.*(R1) + state(:,1).*(~R1); 
        muR2(:,t) = xR.*(R1) + state(:,2).*(~R1);
        
        mu1(:,t) = xR.*(R1) + xP.*(R2) + state(:,1).*(R3);
        mu2(:,t) = xR.*(R1) + xP.*(R2) + state(:,2).*(R3);
        
        pR1(:,t) = muR1(:,t)./exp(a1(:,t))./exp(z(:,t))*M(t);
        pR2(:,t) = muR2(:,t)./exp(a2(:,t))./exp(z(:,t))*M(t);
        p1(:,t)  =  mu1(:,t)./exp(a1(:,t))./exp(z(:,t))*M(t);
        p2(:,t)  =  mu2(:,t)./exp(a2(:,t))./exp(z(:,t))*M(t);
        
        muRold1(:,t) = state(:,1);
        muRold2(:,t) = state(:,2);  
        
        FadjR(t) = mean(R1);
        FadjP(t) = mean(R2);

    end
end

popt1 = gamma/(gamma-1)./exp(a1)./exp(z).*repmat(M',N,1);
popt2 = gamma/(gamma-1)./exp(a2)./exp(z).*repmat(M',N,1);

q1    = exp(a1).^(1-gamma).*(p1./repmat(M',N,1)).^(-gamma);  % partial equilibrium for now
q2    = exp(a2).^(1-gamma).*(p2./repmat(M',N,1)).^(-gamma); 

   p1(:,1:50)=[];
   p2(:,1:50)=[];
   popt1(:,1:50)=[];
   popt2(:,1:50)=[];
   q1(:,1:50)=[];
   q2(:,1:50)=[];
   T = T-50;
   a1(:,1:50)=[];
   a2(:,1:50)=[];
   z(:,1:50)=[];
   mu1(:,1:50)=[];
   mu2(:,1:50)=[];
   muRold1(:,1:50)=[];
   muRold2(:,1:50)=[];
 
   pR1(:,1:50)=[];
   pR2(:,1:50)=[];
   
   preg1 = pR1; 
   preg2 = pR2; 
 
   M(1:50)=[];
   g(1:50)=[];
   FadjR(1:50)=[];
   FadjP(1:50)=[];
   
   
  