function [v1,v2,v3,x,v13,v23,v31,v32] = saveBelmax(c,fspace,s,e,w)

global beta 

ns = length(s);

solve;   

v1 = valfunc1(c,fspace,s,x,e,w);
v2 = valfunc2(c,fspace,s,[],e,w);
v3 = valfunc3(c,fspace,s,[],e,w);


if nargout > 6
    
        g = feval('menufun','g1',s,x,[],w);
        v13 = beta*funbas(fspace,g);
        
        g = feval('menufun','g2',s,[],[],w);
        v23 = beta*funbas(fspace,g);   
        
  nc = size(funbas(fspace,g),2);       
       
  v31 = zeros(ns,nc);      
  v32 = zeros(ns,nc);

    for k=1:length(w)                                      % go over all possible values e (discretized distribution of disturbances) can take
      
       kk = k+zeros(ns,1);
       g = feval('menufun','g3',s,[],e(kk,:),w);
       
       Phi = funbas(fspace,g);

       vint = Phi*c(:,1:2);
       
       c1=(vint(:,1)>=max(vint,[],2));
       c2=(vint(:,2)>=max(vint,[],2))&(c1==0);
    
       v31 = v31 + w(k)*Phi.*repmat(c1,1,nc);   
       v32 = v32 + w(k)*Phi.*repmat(c2,1,nc);  
    
    end
end
