function [out1,out2] = menufun(flag,s,x,e,w)

global  gamma phiR rog

n = size(s,1);

muold1  = s(:,1);
muold2  = s(:,2);

switch flag

case 'b'  % bound for first control
 
  out1 =  exp(-0.05)*gamma/(gamma-1)*ones(n,1);  
  out2 =  exp(+0.05)*gamma/(gamma-1)*ones(n,1);

case 'f1' 
    
mu1 = x;
mu2 = x;

out1 = ((mu1-1).*mu1.^(-gamma)+(mu2-1).*mu2.^(-gamma))-phiR;

case 'f2'
    
mu1 = muold1;
mu2 = muold2;

out1 = ((mu1-1).*mu1.^(-gamma)+(mu2-1).*mu2.^(-gamma));

case 'g1'

mu1 = x;
mu2 = x;    
    
out1=[mu1, mu2, rog*s(:,3)];

case 'g2'
    
out1=[muold1, muold2, rog*s(:,3)];

case 'g3'    
     
out1=[muold1.*exp(e(:,1)-s(:,3)),  muold2.*exp(e(:,2)-s(:,3)), s(:,3)];

end